/* clock.c generated by valac 0.32.1, the Vala compiler
 * generated from clock.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <libpeas/peas.h>
#include <vala-panel-compat.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <lib/misc.h>
#include <lib/css.h>
#include <lib/generic-config-dialog.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>


#define TYPE_CLOCK_APPLET (clock_applet_get_type ())
#define CLOCK_APPLET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOCK_APPLET, ClockApplet))
#define CLOCK_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOCK_APPLET, ClockAppletClass))
#define IS_CLOCK_APPLET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOCK_APPLET))
#define IS_CLOCK_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOCK_APPLET))
#define CLOCK_APPLET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOCK_APPLET, ClockAppletClass))

typedef struct _ClockApplet ClockApplet;
typedef struct _ClockAppletClass ClockAppletClass;
typedef struct _ClockAppletPrivate ClockAppletPrivate;

#define TYPE_CLOCK (clock_get_type ())
#define CLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOCK, Clock))
#define CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOCK, ClockClass))
#define IS_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOCK))
#define IS_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOCK))
#define CLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOCK, ClockClass))

typedef struct _Clock Clock;
typedef struct _ClockClass ClockClass;
typedef struct _ClockPrivate ClockPrivate;

#define CLOCK_TYPE_INTERVAL (clock_interval_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _ClockApplet {
	PeasExtensionBase parent_instance;
	ClockAppletPrivate * priv;
};

struct _ClockAppletClass {
	PeasExtensionBaseClass parent_class;
};

struct _Clock {
	PanelApplet parent_instance;
	ClockPrivate * priv;
};

struct _ClockClass {
	PanelAppletClass parent_class;
};

typedef enum  {
	CLOCK_INTERVAL_AWAITING_FIRST_CHANGE = 0,
	CLOCK_INTERVAL_AWAITING_SECOND_CHANGE = 1,
	CLOCK_INTERVAL_ONE_SECOND = 2,
	CLOCK_INTERVAL_ONE_MINUTE = 3
} ClockInterval;

struct _ClockPrivate {
	GtkToggleButton* clock;
	ClockInterval exp_interval;
	gint exp_count;
	gchar* prev_clock_val;
	guint timer;
	GtkWindow* calendar;
	gchar* _clock_format;
	gchar* _tooltip_format;
	gboolean _bold_font;
};


static gpointer clock_applet_parent_class = NULL;
static ValaPanelAppletPluginIface* clock_applet_vala_panel_applet_plugin_parent_iface = NULL;
static GType clock_applet_type_id = 0;
static gpointer clock_parent_class = NULL;
static ValaPanelAppletConfigurableIface* clock_vala_panel_applet_configurable_parent_iface = NULL;
static GType clock_type_id = 0;

GType clock_applet_get_type (void) G_GNUC_CONST;
GType clock_applet_register_type (GTypeModule * module);
enum  {
	CLOCK_APPLET_DUMMY_PROPERTY
};
static PanelApplet* clock_applet_real_get_applet_widget (ValaPanelAppletPlugin* base, ValaPanelToplevel* toplevel, GSettings* settings, guint number);
Clock* clock_new (ValaPanelToplevel* toplevel, GSettings* settings, guint number);
Clock* clock_construct (GType object_type, ValaPanelToplevel* toplevel, GSettings* settings, guint number);
GType clock_get_type (void) G_GNUC_CONST;
GType clock_register_type (GTypeModule * module);
ClockApplet* clock_applet_new (void);
ClockApplet* clock_applet_construct (GType object_type);
static GType clock_interval_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define CLOCK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CLOCK, ClockPrivate))
enum  {
	CLOCK_DUMMY_PROPERTY,
	CLOCK_CLOCK_FORMAT,
	CLOCK_TOOLTIP_FORMAT,
	CLOCK_BOLD_FONT
};
#define CLOCK_TIP_FORMAT "tooltip-format"
#define CLOCK_LABEL_FORMAT "clock-format"
#define CLOCK_BOLD "bold-font"
static void clock_real_create (PanelApplet* base);
static void __lambda4_ (Clock* self);
static GtkWindow* clock_create_calendar (Clock* self);
static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda5_ (Clock* self, GParamSpec* pspec);
static gchar* clock_get_css (Clock* self);
static void clock_timer_set (Clock* self, GDateTime* current_time);
static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static GtkDialog* clock_real_get_config_dialog (ValaPanelAppletConfigurable* base);
gboolean clock_get_bold_font (Clock* self);
static gboolean clock_update_display (Clock* self);
const gchar* clock_get_clock_format (Clock* self);
const gchar* clock_get_tooltip_format (Clock* self);
static gboolean _clock_update_display_gsource_func (gpointer self);
void clock_set_clock_format (Clock* self, const gchar* value);
void clock_set_tooltip_format (Clock* self, const gchar* value);
void clock_set_bold_font (Clock* self, gboolean value);
static void clock_finalize (GObject* obj);
static void _vala_clock_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_clock_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
void peas_register_types (GTypeModule* module);


static PanelApplet* clock_applet_real_get_applet_widget (ValaPanelAppletPlugin* base, ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	ClockApplet * self;
	PanelApplet* result = NULL;
	ValaPanelToplevel* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	Clock* _tmp3_ = NULL;
	self = (ClockApplet*) base;
	g_return_val_if_fail (toplevel != NULL, NULL);
	_tmp0_ = toplevel;
	_tmp1_ = settings;
	_tmp2_ = number;
	_tmp3_ = clock_new (_tmp0_, _tmp1_, _tmp2_);
	g_object_ref_sink (_tmp3_);
	result = (PanelApplet*) _tmp3_;
	return result;
}


ClockApplet* clock_applet_construct (GType object_type) {
	ClockApplet * self = NULL;
	self = (ClockApplet*) g_object_new (object_type, NULL);
	return self;
}


ClockApplet* clock_applet_new (void) {
	return clock_applet_construct (TYPE_CLOCK_APPLET);
}


static void clock_applet_class_init (ClockAppletClass * klass) {
	clock_applet_parent_class = g_type_class_peek_parent (klass);
}


static void clock_applet_vala_panel_applet_plugin_interface_init (ValaPanelAppletPluginIface * iface) {
	clock_applet_vala_panel_applet_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_applet_widget = (PanelApplet* (*)(ValaPanelAppletPlugin*, ValaPanelToplevel*, GSettings*, guint)) clock_applet_real_get_applet_widget;
}


static void clock_applet_instance_init (ClockApplet * self) {
}


GType clock_applet_get_type (void) {
	return clock_applet_type_id;
}


GType clock_applet_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (ClockAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClockApplet), 0, (GInstanceInitFunc) clock_applet_instance_init, NULL };
	static const GInterfaceInfo vala_panel_applet_plugin_info = { (GInterfaceInitFunc) clock_applet_vala_panel_applet_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	clock_applet_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "ClockApplet", &g_define_type_info, 0);
	g_type_module_add_interface (module, clock_applet_type_id, VALA_PANEL_TYPE_APPLET_PLUGIN, &vala_panel_applet_plugin_info);
	return clock_applet_type_id;
}


static GType clock_interval_get_type (void) {
	static volatile gsize clock_interval_type_id__volatile = 0;
	if (g_once_init_enter (&clock_interval_type_id__volatile)) {
		static const GEnumValue values[] = {{CLOCK_INTERVAL_AWAITING_FIRST_CHANGE, "CLOCK_INTERVAL_AWAITING_FIRST_CHANGE", "awaiting-first-change"}, {CLOCK_INTERVAL_AWAITING_SECOND_CHANGE, "CLOCK_INTERVAL_AWAITING_SECOND_CHANGE", "awaiting-second-change"}, {CLOCK_INTERVAL_ONE_SECOND, "CLOCK_INTERVAL_ONE_SECOND", "one-second"}, {CLOCK_INTERVAL_ONE_MINUTE, "CLOCK_INTERVAL_ONE_MINUTE", "one-minute"}, {0, NULL, NULL}};
		GType clock_interval_type_id;
		clock_interval_type_id = g_enum_register_static ("ClockInterval", values);
		g_once_init_leave (&clock_interval_type_id__volatile, clock_interval_type_id);
	}
	return clock_interval_type_id__volatile;
}


Clock* clock_construct (GType object_type, ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	Clock * self = NULL;
	ValaPanelToplevel* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	g_return_val_if_fail (toplevel != NULL, NULL);
	_tmp0_ = toplevel;
	_tmp1_ = settings;
	_tmp2_ = number;
	self = (Clock*) vala_panel_applet_construct (object_type, _tmp0_, _tmp1_, _tmp2_);
	return self;
}


Clock* clock_new (ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	return clock_construct (TYPE_CLOCK, toplevel, settings, number);
}


static void __lambda4_ (Clock* self) {
	GtkToggleButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	_tmp0_ = self->priv->clock;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	if (_tmp1_) {
		GtkWindow* _tmp2_ = NULL;
		GtkWindow* _tmp3_ = NULL;
		_tmp2_ = clock_create_calendar (self);
		_g_object_unref0 (self->priv->calendar);
		self->priv->calendar = _tmp2_;
		_tmp3_ = self->priv->calendar;
		gtk_widget_show_all ((GtkWidget*) _tmp3_);
	} else {
		GtkWindow* _tmp4_ = NULL;
		_tmp4_ = self->priv->calendar;
		gtk_widget_destroy ((GtkWidget*) _tmp4_);
		_g_object_unref0 (self->priv->calendar);
		self->priv->calendar = NULL;
	}
}


static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda4_ ((Clock*) self);
}


static void __lambda5_ (Clock* self, GParamSpec* pspec) {
	GParamSpec* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (pspec != NULL);
	_tmp0_ = pspec;
	_tmp1_ = _tmp0_->name;
	if (g_strcmp0 (_tmp1_, CLOCK_BOLD) == 0) {
		GtkToggleButton* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp2_ = self->priv->clock;
		_tmp3_ = clock_get_css (self);
		_tmp4_ = _tmp3_;
		css_apply_with_class ((GtkWidget*) _tmp2_, _tmp4_, "-vala-panel-font-weight", FALSE);
		_g_free0 (_tmp4_);
	} else {
		guint _tmp5_ = 0U;
		GDateTime* now = NULL;
		GDateTime* _tmp7_ = NULL;
		GDateTime* _tmp8_ = NULL;
		GtkWindow* _tmp9_ = NULL;
		_tmp5_ = self->priv->timer;
		if (_tmp5_ != ((guint) 0)) {
			guint _tmp6_ = 0U;
			_tmp6_ = self->priv->timer;
			g_source_remove (_tmp6_);
		}
		_g_free0 (self->priv->prev_clock_val);
		self->priv->prev_clock_val = NULL;
		self->priv->exp_count = 0;
		self->priv->exp_interval = CLOCK_INTERVAL_AWAITING_FIRST_CHANGE;
		_tmp7_ = g_date_time_new_now_local ();
		now = _tmp7_;
		_tmp8_ = now;
		clock_timer_set (self, _tmp8_);
		_tmp9_ = self->priv->calendar;
		if (_tmp9_ != NULL) {
			GtkWindow* _tmp10_ = NULL;
			_tmp10_ = self->priv->calendar;
			gtk_widget_destroy ((GtkWidget*) _tmp10_);
			_g_object_unref0 (self->priv->calendar);
			self->priv->calendar = NULL;
		}
		_g_date_time_unref0 (now);
	}
}


static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda5_ ((Clock*) self, pspec);
}


static void clock_real_create (PanelApplet* base) {
	Clock * self;
	GSettings* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	GSettings* _tmp2_ = NULL;
	GSettings* _tmp3_ = NULL;
	GSettings* _tmp4_ = NULL;
	GSettings* _tmp5_ = NULL;
	GtkToggleButton* _tmp6_ = NULL;
	GtkToggleButton* _tmp7_ = NULL;
	GtkToggleButton* _tmp8_ = NULL;
	GtkToggleButton* _tmp9_ = NULL;
	GtkToggleButton* _tmp10_ = NULL;
	self = (Clock*) base;
	_tmp0_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp1_ = _tmp0_;
	g_settings_bind (_tmp1_, CLOCK_LABEL_FORMAT, (GObject*) self, CLOCK_LABEL_FORMAT, G_SETTINGS_BIND_GET);
	_tmp2_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp3_ = _tmp2_;
	g_settings_bind (_tmp3_, CLOCK_TIP_FORMAT, (GObject*) self, CLOCK_TIP_FORMAT, G_SETTINGS_BIND_GET);
	_tmp4_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp5_ = _tmp4_;
	g_settings_bind (_tmp5_, CLOCK_BOLD, (GObject*) self, CLOCK_BOLD, G_SETTINGS_BIND_GET);
	_tmp6_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->clock);
	self->priv->clock = _tmp6_;
	_tmp7_ = self->priv->clock;
	vala_panel_setup_button (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_button_get_type ()) ? ((GtkButton*) _tmp7_) : NULL, NULL, NULL);
	_tmp8_ = self->priv->clock;
	g_signal_connect_object (_tmp8_, "toggled", (GCallback) ___lambda4__gtk_toggle_button_toggled, self, 0);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda5__g_object_notify, self, 0);
	_tmp9_ = self->priv->clock;
	gtk_widget_show ((GtkWidget*) _tmp9_);
	_tmp10_ = self->priv->clock;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp10_);
	gtk_widget_show_all ((GtkWidget*) self);
}


static GtkDialog* clock_real_get_config_dialog (ValaPanelAppletConfigurable* base) {
	Clock * self;
	GtkDialog* result = NULL;
	const gchar* _tmp0_ = NULL;
	ValaPanelToplevel* _tmp1_ = NULL;
	ValaPanelToplevel* _tmp2_ = NULL;
	GSettings* _tmp3_ = NULL;
	GSettings* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	GtkDialog* _tmp9_ = NULL;
	self = (Clock*) base;
	_tmp0_ = _ ("Digital Clock");
	_tmp1_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = _ ("Clock Format");
	_tmp6_ = _ ("Tooltip Format");
	_tmp7_ = _ ("Format codes: man 3 strftime; %n for line break");
	_tmp8_ = _ ("Bold font");
	_tmp9_ = generic_config_dlg (_tmp0_, (GtkWindow*) _tmp2_, _tmp4_, _tmp5_, CLOCK_LABEL_FORMAT, CONF_STR, _tmp6_, CLOCK_TIP_FORMAT, CONF_STR, _tmp7_, NULL, CONF_TRIM, _tmp8_, CLOCK_BOLD, CONF_BOOL, NULL);
	result = _tmp9_;
	return result;
}


static gchar* clock_get_css (Clock* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_bold_font;
	if (_tmp1_) {
		_tmp0_ = "bold";
	} else {
		_tmp0_ = "normal";
	}
	_tmp2_ = g_strdup_printf (" font-weight: %s;\n", _tmp0_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (".-vala-panel-font-weight{\n", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp5_, "}", NULL);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	result = _tmp7_;
	return result;
}


static GtkWindow* clock_create_calendar (Clock* self) {
	GtkWindow* result = NULL;
	GtkWindow* win = NULL;
	GtkWindow* _tmp0_ = NULL;
	GtkCalendar* calendar = NULL;
	GtkCalendar* _tmp1_ = NULL;
	GDateTime* now = NULL;
	GDateTime* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	ValaPanelToplevel* _tmp4_ = NULL;
	ValaPanelToplevel* _tmp5_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_POPUP);
	g_object_ref_sink (_tmp0_);
	win = _tmp0_;
	gtk_window_set_default_size (win, 180, 180);
	gtk_container_set_border_width ((GtkContainer*) win, (guint) 5);
	_tmp1_ = (GtkCalendar*) gtk_calendar_new ();
	g_object_ref_sink (_tmp1_);
	calendar = _tmp1_;
	_tmp2_ = g_date_time_new_now_local ();
	now = _tmp2_;
	gtk_calendar_set_display_options (calendar, (GTK_CALENDAR_SHOW_WEEK_NUMBERS | GTK_CALENDAR_SHOW_DAY_NAMES) | GTK_CALENDAR_SHOW_HEADING);
	_tmp3_ = g_date_time_get_day_of_month (now);
	gtk_calendar_mark_day (calendar, (guint) _tmp3_);
	gtk_container_add ((GtkContainer*) win, (GtkWidget*) calendar);
	gtk_window_set_type_hint (win, GDK_WINDOW_TYPE_HINT_UTILITY);
	_tmp4_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
	_tmp5_ = _tmp4_;
	gtk_window_set_transient_for (win, (GtkWindow*) _tmp5_);
	gtk_window_set_attached_to (win, (GtkWidget*) self);
	gtk_widget_show_all ((GtkWidget*) calendar);
	vala_panel_applet_set_popup_position ((PanelApplet*) self, (GtkWidget*) win);
	result = win;
	_g_date_time_unref0 (now);
	_g_object_unref0 (calendar);
	return result;
}


static gboolean clock_update_display (Clock* self) {
	gboolean result = FALSE;
	GDateTime* now = NULL;
	GDateTime* _tmp0_ = NULL;
	GSource* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GDateTime* _tmp3_ = NULL;
	gchar* label = NULL;
	GDateTime* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* tooltip = NULL;
	GDateTime* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	GtkToggleButton* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	GtkToggleButton* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	ClockInterval _tmp14_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = g_main_current_source ();
	_tmp2_ = g_source_is_destroyed (_tmp1_);
	if (_tmp2_) {
		result = FALSE;
		_g_date_time_unref0 (now);
		return result;
	}
	_tmp3_ = now;
	clock_timer_set (self, _tmp3_);
	_tmp4_ = now;
	_tmp5_ = self->priv->_clock_format;
	_tmp6_ = g_date_time_format (_tmp4_, _tmp5_);
	label = _tmp6_;
	_tmp7_ = now;
	_tmp8_ = self->priv->_tooltip_format;
	_tmp9_ = g_date_time_format (_tmp7_, _tmp8_);
	tooltip = _tmp9_;
	_tmp10_ = self->priv->clock;
	_tmp11_ = label;
	gtk_button_set_label ((GtkButton*) _tmp10_, _tmp11_);
	_tmp12_ = self->priv->clock;
	_tmp13_ = tooltip;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp12_, _tmp13_);
	_tmp14_ = self->priv->exp_interval;
	if (_tmp14_ < CLOCK_INTERVAL_ONE_SECOND) {
		const gchar* _tmp15_ = NULL;
		_tmp15_ = self->priv->prev_clock_val;
		if (_tmp15_ == NULL) {
			const gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
			_tmp16_ = label;
			_tmp17_ = g_strdup (_tmp16_);
			_g_free0 (self->priv->prev_clock_val);
			self->priv->prev_clock_val = _tmp17_;
		} else {
			const gchar* _tmp18_ = NULL;
			const gchar* _tmp19_ = NULL;
			_tmp18_ = self->priv->prev_clock_val;
			_tmp19_ = label;
			if (g_strcmp0 (_tmp18_, _tmp19_) == 0) {
				gint _tmp20_ = 0;
				gint _tmp21_ = 0;
				_tmp20_ = self->priv->exp_count;
				self->priv->exp_count = _tmp20_ + 1;
				_tmp21_ = self->priv->exp_count;
				if (_tmp21_ > 3) {
					self->priv->exp_interval = CLOCK_INTERVAL_ONE_MINUTE;
					_g_free0 (self->priv->prev_clock_val);
					self->priv->prev_clock_val = NULL;
				}
			} else {
				ClockInterval _tmp22_ = 0;
				_tmp22_ = self->priv->exp_interval;
				if (_tmp22_ == CLOCK_INTERVAL_AWAITING_FIRST_CHANGE) {
					const gchar* _tmp23_ = NULL;
					gchar* _tmp24_ = NULL;
					self->priv->exp_interval = CLOCK_INTERVAL_AWAITING_SECOND_CHANGE;
					self->priv->exp_count = 0;
					_tmp23_ = label;
					_tmp24_ = g_strdup (_tmp23_);
					_g_free0 (self->priv->prev_clock_val);
					self->priv->prev_clock_val = _tmp24_;
				} else {
					ClockInterval _tmp25_ = 0;
					gint _tmp26_ = 0;
					_tmp26_ = self->priv->exp_count;
					if (_tmp26_ > 3) {
						_tmp25_ = CLOCK_INTERVAL_ONE_MINUTE;
					} else {
						_tmp25_ = CLOCK_INTERVAL_ONE_SECOND;
					}
					self->priv->exp_interval = _tmp25_;
					_g_free0 (self->priv->prev_clock_val);
					self->priv->prev_clock_val = NULL;
				}
			}
		}
	}
	result = FALSE;
	_g_free0 (tooltip);
	_g_free0 (label);
	_g_date_time_unref0 (now);
	return result;
}


static gboolean _clock_update_display_gsource_func (gpointer self) {
	gboolean result;
	result = clock_update_display ((Clock*) self);
	return result;
}


static void clock_timer_set (Clock* self, GDateTime* current_time) {
	guint microseconds = 0U;
	GDateTime* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	ClockInterval _tmp2_ = 0;
	guint _tmp7_ = 0U;
	guint _tmp8_ = 0U;
	guint _tmp9_ = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (current_time != NULL);
	microseconds = (guint) 1000000;
	_tmp0_ = current_time;
	_tmp1_ = g_date_time_get_microsecond (_tmp0_);
	microseconds = (guint) (1000000 - _tmp1_);
	_tmp2_ = self->priv->exp_interval;
	if (_tmp2_ == CLOCK_INTERVAL_ONE_MINUTE) {
		guint seconds = 0U;
		GDateTime* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		guint _tmp5_ = 0U;
		guint _tmp6_ = 0U;
		_tmp3_ = current_time;
		_tmp4_ = g_date_time_get_second (_tmp3_);
		seconds = (guint) (60 - _tmp4_);
		_tmp5_ = microseconds;
		_tmp6_ = seconds;
		microseconds = _tmp5_ + (_tmp6_ * 1000000);
	}
	_tmp7_ = microseconds;
	if (_tmp7_ <= ((guint) 0)) {
		microseconds = (guint) 1000000;
	}
	_tmp8_ = microseconds;
	_tmp9_ = g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp8_ / 1000, _clock_update_display_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->timer = _tmp9_;
}


const gchar* clock_get_clock_format (Clock* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_clock_format;
	result = _tmp0_;
	return result;
}


void clock_set_clock_format (Clock* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_clock_format);
	self->priv->_clock_format = _tmp1_;
	g_object_notify ((GObject *) self, "clock-format");
}


const gchar* clock_get_tooltip_format (Clock* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tooltip_format;
	result = _tmp0_;
	return result;
}


void clock_set_tooltip_format (Clock* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_tooltip_format);
	self->priv->_tooltip_format = _tmp1_;
	g_object_notify ((GObject *) self, "tooltip-format");
}


gboolean clock_get_bold_font (Clock* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_bold_font;
	result = _tmp0_;
	return result;
}


void clock_set_bold_font (Clock* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_bold_font = _tmp0_;
	g_object_notify ((GObject *) self, "bold-font");
}


static void clock_class_init (ClockClass * klass) {
	clock_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ClockPrivate));
	((PanelAppletClass *) klass)->create = clock_real_create;
	G_OBJECT_CLASS (klass)->get_property = _vala_clock_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_clock_set_property;
	G_OBJECT_CLASS (klass)->finalize = clock_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_CLOCK_FORMAT, g_param_spec_string ("clock-format", "clock-format", "clock-format", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_TOOLTIP_FORMAT, g_param_spec_string ("tooltip-format", "tooltip-format", "tooltip-format", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_BOLD_FONT, g_param_spec_boolean ("bold-font", "bold-font", "bold-font", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void clock_vala_panel_applet_configurable_interface_init (ValaPanelAppletConfigurableIface * iface) {
	clock_vala_panel_applet_configurable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_config_dialog = (GtkDialog* (*)(ValaPanelAppletConfigurable*)) clock_real_get_config_dialog;
}


static void clock_instance_init (Clock * self) {
	self->priv = CLOCK_GET_PRIVATE (self);
}


static void clock_finalize (GObject* obj) {
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOCK, Clock);
	_g_object_unref0 (self->priv->clock);
	_g_free0 (self->priv->prev_clock_val);
	_g_object_unref0 (self->priv->calendar);
	_g_free0 (self->priv->_clock_format);
	_g_free0 (self->priv->_tooltip_format);
	G_OBJECT_CLASS (clock_parent_class)->finalize (obj);
}


GType clock_get_type (void) {
	return clock_type_id;
}


GType clock_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (ClockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Clock), 0, (GInstanceInitFunc) clock_instance_init, NULL };
	static const GInterfaceInfo vala_panel_applet_configurable_info = { (GInterfaceInitFunc) clock_vala_panel_applet_configurable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	clock_type_id = g_type_module_register_type (module, VALA_PANEL_TYPE_APPLET, "Clock", &g_define_type_info, 0);
	g_type_module_add_interface (module, clock_type_id, VALA_PANEL_TYPE_APPLET_CONFIGURABLE, &vala_panel_applet_configurable_info);
	return clock_type_id;
}


static void _vala_clock_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK, Clock);
	switch (property_id) {
		case CLOCK_CLOCK_FORMAT:
		g_value_set_string (value, clock_get_clock_format (self));
		break;
		case CLOCK_TOOLTIP_FORMAT:
		g_value_set_string (value, clock_get_tooltip_format (self));
		break;
		case CLOCK_BOLD_FONT:
		g_value_set_boolean (value, clock_get_bold_font (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_clock_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK, Clock);
	switch (property_id) {
		case CLOCK_CLOCK_FORMAT:
		clock_set_clock_format (self, g_value_get_string (value));
		break;
		case CLOCK_TOOLTIP_FORMAT:
		clock_set_tooltip_format (self, g_value_get_string (value));
		break;
		case CLOCK_BOLD_FONT:
		clock_set_bold_font (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void peas_register_types (GTypeModule* module) {
	PeasObjectModule* objmodule = NULL;
	GTypeModule* _tmp0_ = NULL;
	PeasObjectModule* _tmp1_ = NULL;
	g_return_if_fail (module != NULL);
	clock_applet_register_type (module);
	clock_register_type (module);
	_tmp0_ = module;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, peas_object_module_get_type ()) ? ((PeasObjectModule*) _tmp0_) : NULL);
	objmodule = _tmp1_;
	peas_object_module_register_extension_type (objmodule, VALA_PANEL_TYPE_APPLET_PLUGIN, TYPE_CLOCK_APPLET);
	_g_object_unref0 (objmodule);
}



