/* menumodel.c generated by valac 0.32.1, the Vala compiler
 * generated from menumodel.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <libpeas/peas.h>
#include <vala-panel-compat.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <lib/generic-config-dialog.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <lib/menu-maker.h>
#include <lib/misc.h>


#define TYPE_MENU_APPLET (menu_applet_get_type ())
#define MENU_APPLET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MENU_APPLET, MenuApplet))
#define MENU_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MENU_APPLET, MenuAppletClass))
#define IS_MENU_APPLET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MENU_APPLET))
#define IS_MENU_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MENU_APPLET))
#define MENU_APPLET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MENU_APPLET, MenuAppletClass))

typedef struct _MenuApplet MenuApplet;
typedef struct _MenuAppletClass MenuAppletClass;
typedef struct _MenuAppletPrivate MenuAppletPrivate;

#define TYPE_MENU (menu_get_type ())
#define MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MENU, Menu))
#define MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MENU, MenuClass))
#define IS_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MENU))
#define IS_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MENU))
#define MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MENU, MenuClass))

typedef struct _Menu Menu;
typedef struct _MenuClass MenuClass;

#define TYPE_INTERNAL_MENU (internal_menu_get_type ())
typedef struct _MenuPrivate MenuPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _MenuApplet {
	PeasExtensionBase parent_instance;
	MenuAppletPrivate * priv;
};

struct _MenuAppletClass {
	PeasExtensionBaseClass parent_class;
};

typedef enum  {
	INTERNAL_MENU_SETTINGS,
	INTERNAL_MENU_APPLICATIONS,
	INTERNAL_MENU_RECENT,
	INTERNAL_MENU_MOUNTS
} InternalMenu;

struct _Menu {
	PanelApplet parent_instance;
	MenuPrivate * priv;
};

struct _MenuClass {
	PanelAppletClass parent_class;
};

struct _MenuPrivate {
	GMenu* menu;
	GtkContainer* button;
	GtkMenu* int_menu;
	GAppInfoMonitor* app_monitor;
	GFileMonitor* file_monitor;
	gulong show_system_menu_idle;
	gchar* _icon;
	gboolean _system;
	gboolean _intern;
	gboolean _bar;
	gchar* _caption;
	gchar* _filename;
};

struct _Block1Data {
	int _ref_count_;
	Menu* self;
	GtkMenuBar* menubar;
	GtkPackDirection orient;
};

struct _Block2Data {
	int _ref_count_;
	Menu* self;
	GtkToggleButton* menubutton;
};


static gpointer menu_applet_parent_class = NULL;
static ValaPanelAppletPluginIface* menu_applet_vala_panel_applet_plugin_parent_iface = NULL;
static GType menu_applet_type_id = 0;
static gpointer menu_parent_class = NULL;
static ValaPanelAppletConfigurableIface* menu_vala_panel_applet_configurable_parent_iface = NULL;
static ValaPanelAppletMenuIface* menu_vala_panel_applet_menu_parent_iface = NULL;
static GType menu_type_id = 0;

GType menu_applet_get_type (void) G_GNUC_CONST;
GType menu_applet_register_type (GTypeModule * module);
enum  {
	MENU_APPLET_DUMMY_PROPERTY
};
static PanelApplet* menu_applet_real_get_applet_widget (ValaPanelAppletPlugin* base, ValaPanelToplevel* toplevel, GSettings* settings, guint number);
Menu* menu_new (ValaPanelToplevel* toplevel, GSettings* settings, guint number);
Menu* menu_construct (GType object_type, ValaPanelToplevel* toplevel, GSettings* settings, guint number);
GType menu_get_type (void) G_GNUC_CONST;
GType menu_register_type (GTypeModule * module);
MenuApplet* menu_applet_new (void);
MenuApplet* menu_applet_construct (GType object_type);
#define KEY_ICON "icon-name"
#define KEY_CAPTION "menu-caption"
#define KEY_IS_MENU_BAR "is-menu-bar"
#define KEY_IS_SYSTEM_MENU "is-system-menu"
#define KEY_IS_INTERNAL_MENU "is-internal-menu"
#define KEY_MODEL_FILE "model-file"
GType internal_menu_get_type (void) G_GNUC_CONST;
#define MENU_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MENU, MenuPrivate))
enum  {
	MENU_DUMMY_PROPERTY,
	MENU_ICON,
	MENU_SYSTEM,
	MENU_INTERN,
	MENU_BAR,
	MENU_CAPTION,
	MENU_FILENAME
};
static void menu_real_destroy (GtkWidget* base);
static void menu_menumodel_widget_destroy (Menu* self);
static GtkDialog* menu_real_get_config_dialog (ValaPanelAppletConfigurable* base);
static void menu_real_show_system_menu (ValaPanelAppletMenu* base);
gboolean menu_get_system (Menu* self);
gboolean menu_show_menu (Menu* self);
static gboolean _menu_show_menu_gsource_func (gpointer self);
static void _vala_panel_applet_menu_position_func_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self);
static void menu_real_create (PanelApplet* base);
static GtkContainer* menu_menumodel_widget_create (Menu* self);
static void __lambda7_ (Menu* self, const gchar* key);
gboolean menu_get_intern (Menu* self);
gboolean menu_get_bar (Menu* self);
static void menu_menumodel_widget_rebuild (Menu* self);
const gchar* menu_get_caption (Menu* self);
const gchar* menu_get_icon (Menu* self);
static void ___lambda7__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
static GMenuModel* menu_create_menumodel (Menu* self);
static GtkMenuBar* menu_create_menubar (Menu* self);
static GtkToggleButton* menu_create_menubutton (Menu* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda4_ (Block1Data* _data1_);
static void ___lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda5_ (Block2Data* _data2_);
static void ___lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda6_ (Block2Data* _data2_);
static void ___lambda6__gtk_widget_hide (GtkWidget* _sender, gpointer self);
GMenuModel* menu_maker_create_main_menu (gboolean submenus, const gchar* icon);
static void _menu_menumodel_widget_rebuild_g_app_info_monitor_changed (GAppInfoMonitor* _sender, gpointer self);
const gchar* menu_get_filename (Menu* self);
static GMenuModel* menu_read_menumodel (Menu* self);
static void _menu_menumodel_widget_rebuild_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static void menu_load_internal_menus (GMenu* int_menu, InternalMenu req);
GMenuModel* menu_maker_create_applications_menu (gboolean do_settings);
void menu_set_icon (Menu* self, const gchar* value);
void menu_set_system (Menu* self, gboolean value);
void menu_set_intern (Menu* self, gboolean value);
void menu_set_bar (Menu* self, gboolean value);
void menu_set_caption (Menu* self, const gchar* value);
void menu_set_filename (Menu* self, const gchar* value);
static void menu_finalize (GObject* obj);
static void _vala_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
void peas_register_types (GTypeModule* module);


static PanelApplet* menu_applet_real_get_applet_widget (ValaPanelAppletPlugin* base, ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	MenuApplet * self;
	PanelApplet* result = NULL;
	ValaPanelToplevel* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	Menu* _tmp3_ = NULL;
	self = (MenuApplet*) base;
	g_return_val_if_fail (toplevel != NULL, NULL);
	_tmp0_ = toplevel;
	_tmp1_ = settings;
	_tmp2_ = number;
	_tmp3_ = menu_new (_tmp0_, _tmp1_, _tmp2_);
	g_object_ref_sink (_tmp3_);
	result = (PanelApplet*) _tmp3_;
	return result;
}


MenuApplet* menu_applet_construct (GType object_type) {
	MenuApplet * self = NULL;
	self = (MenuApplet*) g_object_new (object_type, NULL);
	return self;
}


MenuApplet* menu_applet_new (void) {
	return menu_applet_construct (TYPE_MENU_APPLET);
}


static void menu_applet_class_init (MenuAppletClass * klass) {
	menu_applet_parent_class = g_type_class_peek_parent (klass);
}


static void menu_applet_vala_panel_applet_plugin_interface_init (ValaPanelAppletPluginIface * iface) {
	menu_applet_vala_panel_applet_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_applet_widget = (PanelApplet* (*)(ValaPanelAppletPlugin*, ValaPanelToplevel*, GSettings*, guint)) menu_applet_real_get_applet_widget;
}


static void menu_applet_instance_init (MenuApplet * self) {
}


GType menu_applet_get_type (void) {
	return menu_applet_type_id;
}


GType menu_applet_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MenuAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) menu_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MenuApplet), 0, (GInstanceInitFunc) menu_applet_instance_init, NULL };
	static const GInterfaceInfo vala_panel_applet_plugin_info = { (GInterfaceInitFunc) menu_applet_vala_panel_applet_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	menu_applet_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "MenuApplet", &g_define_type_info, 0);
	g_type_module_add_interface (module, menu_applet_type_id, VALA_PANEL_TYPE_APPLET_PLUGIN, &vala_panel_applet_plugin_info);
	return menu_applet_type_id;
}


GType internal_menu_get_type (void) {
	static volatile gsize internal_menu_type_id__volatile = 0;
	if (g_once_init_enter (&internal_menu_type_id__volatile)) {
		static const GEnumValue values[] = {{INTERNAL_MENU_SETTINGS, "INTERNAL_MENU_SETTINGS", "settings"}, {INTERNAL_MENU_APPLICATIONS, "INTERNAL_MENU_APPLICATIONS", "applications"}, {INTERNAL_MENU_RECENT, "INTERNAL_MENU_RECENT", "recent"}, {INTERNAL_MENU_MOUNTS, "INTERNAL_MENU_MOUNTS", "mounts"}, {0, NULL, NULL}};
		GType internal_menu_type_id;
		internal_menu_type_id = g_enum_register_static ("InternalMenu", values);
		g_once_init_leave (&internal_menu_type_id__volatile, internal_menu_type_id);
	}
	return internal_menu_type_id__volatile;
}


Menu* menu_construct (GType object_type, ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	Menu * self = NULL;
	ValaPanelToplevel* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	g_return_val_if_fail (toplevel != NULL, NULL);
	_tmp0_ = toplevel;
	_tmp1_ = settings;
	_tmp2_ = number;
	self = (Menu*) vala_panel_applet_construct (object_type, _tmp0_, _tmp1_, _tmp2_);
	return self;
}


Menu* menu_new (ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	return menu_construct (TYPE_MENU, toplevel, settings, number);
}


static void menu_real_destroy (GtkWidget* base) {
	Menu * self;
	self = (Menu*) base;
	menu_menumodel_widget_destroy (self);
	GTK_WIDGET_CLASS (menu_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_PANEL_TYPE_APPLET, PanelApplet));
}


static GtkDialog* menu_real_get_config_dialog (ValaPanelAppletConfigurable* base) {
	Menu * self;
	GtkDialog* result = NULL;
	const gchar* _tmp0_ = NULL;
	ValaPanelToplevel* _tmp1_ = NULL;
	ValaPanelToplevel* _tmp2_ = NULL;
	GSettings* _tmp3_ = NULL;
	GSettings* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	GtkDialog* _tmp12_ = NULL;
	self = (Menu*) base;
	_tmp0_ = _ ("Custom Menu");
	_tmp1_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = _ ("If internal menu is enabled, menu file will not be used, predefeined m" \
"enu will be used instead.");
	_tmp6_ = _ ("Is internal menu");
	_tmp7_ = _ ("Is system menu (can be keybound)");
	_tmp8_ = _ ("Is Menubar");
	_tmp9_ = _ ("Icon");
	_tmp10_ = _ ("Caption (for button only)");
	_tmp11_ = _ ("Menu file name");
	_tmp12_ = generic_config_dlg (_tmp0_, (GtkWindow*) _tmp2_, _tmp4_, _tmp5_, NULL, CONF_TRIM, _tmp6_, KEY_IS_INTERNAL_MENU, CONF_BOOL, _tmp7_, KEY_IS_SYSTEM_MENU, CONF_BOOL, _tmp8_, KEY_IS_MENU_BAR, CONF_BOOL, _tmp9_, KEY_ICON, CONF_FILE_ENTRY, _tmp10_, KEY_CAPTION, CONF_STR, _tmp11_, KEY_MODEL_FILE, CONF_FILE_ENTRY, NULL);
	result = _tmp12_;
	return result;
}


static gboolean _menu_show_menu_gsource_func (gpointer self) {
	gboolean result;
	result = menu_show_menu ((Menu*) self);
	return result;
}


static void menu_real_show_system_menu (ValaPanelAppletMenu* base) {
	Menu * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	self = (Menu*) base;
	_tmp1_ = self->priv->_system;
	if (_tmp1_) {
		gulong _tmp2_ = 0UL;
		_tmp2_ = self->priv->show_system_menu_idle;
		_tmp0_ = _tmp2_ == ((gulong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _menu_show_menu_gsource_func, g_object_ref (self), g_object_unref);
	}
}


static void _vala_panel_applet_menu_position_func_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self) {
	vala_panel_applet_menu_position_func ((PanelApplet*) self, menu, x, y, push_in);
	g_object_unref (self);
}


gboolean menu_show_menu (Menu* self) {
	gboolean result = FALSE;
	GSource* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GtkMenu* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_main_current_source ();
	_tmp1_ = g_source_is_destroyed (_tmp0_);
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = self->priv->int_menu;
	if (_tmp2_ != NULL) {
		GtkMenu* _tmp3_ = NULL;
		_tmp3_ = self->priv->int_menu;
		gtk_menu_popup (_tmp3_, NULL, NULL, _vala_panel_applet_menu_position_func_gtk_menu_position_func, g_object_ref ((PanelApplet*) self), (guint) 0, (guint32) GDK_CURRENT_TIME);
	} else {
		GtkMenuBar* menubar = NULL;
		GtkContainer* _tmp4_ = NULL;
		GtkMenuBar* _tmp5_ = NULL;
		_tmp4_ = self->priv->button;
		menubar = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_menu_bar_get_type ()) ? ((GtkMenuBar*) _tmp4_) : NULL;
		_tmp5_ = menubar;
		gtk_menu_shell_select_first ((GtkMenuShell*) _tmp5_, FALSE);
	}
	self->priv->show_system_menu_idle = (gulong) 0;
	result = FALSE;
	return result;
}


static void __lambda7_ (Menu* self, const gchar* key) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (key != NULL);
	_tmp3_ = key;
	if (g_strcmp0 (_tmp3_, KEY_IS_INTERNAL_MENU) == 0) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_ = NULL;
		_tmp5_ = key;
		if (g_strcmp0 (_tmp5_, KEY_MODEL_FILE) == 0) {
			gboolean _tmp6_ = FALSE;
			_tmp6_ = self->priv->_intern;
			_tmp4_ = !_tmp6_;
		} else {
			_tmp4_ = FALSE;
		}
		_tmp2_ = _tmp4_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp7_ = NULL;
		_tmp7_ = key;
		_tmp1_ = g_strcmp0 (_tmp7_, KEY_IS_MENU_BAR) == 0;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp8_ = FALSE;
		const gchar* _tmp9_ = NULL;
		_tmp9_ = key;
		if (g_strcmp0 (_tmp9_, KEY_ICON) == 0) {
			gboolean _tmp10_ = FALSE;
			_tmp10_ = self->priv->_bar;
			_tmp8_ = _tmp10_;
		} else {
			_tmp8_ = FALSE;
		}
		_tmp0_ = _tmp8_;
	}
	if (_tmp0_) {
		menu_menumodel_widget_rebuild (self);
	} else {
		gboolean _tmp11_ = FALSE;
		const gchar* _tmp12_ = NULL;
		_tmp12_ = key;
		if (g_strcmp0 (_tmp12_, KEY_CAPTION) == 0) {
			gboolean _tmp13_ = FALSE;
			_tmp13_ = self->priv->_bar;
			_tmp11_ = !_tmp13_;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			GtkButton* btn = NULL;
			GtkContainer* _tmp14_ = NULL;
			GtkButton* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			_tmp14_ = self->priv->button;
			btn = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, gtk_button_get_type ()) ? ((GtkButton*) _tmp14_) : NULL;
			_tmp15_ = btn;
			_tmp16_ = self->priv->_caption;
			gtk_button_set_label (_tmp15_, _tmp16_);
		} else {
			gboolean _tmp17_ = FALSE;
			const gchar* _tmp18_ = NULL;
			_tmp18_ = key;
			if (g_strcmp0 (_tmp18_, KEY_ICON) == 0) {
				gboolean _tmp19_ = FALSE;
				_tmp19_ = self->priv->_bar;
				_tmp17_ = !_tmp19_;
			} else {
				_tmp17_ = FALSE;
			}
			if (_tmp17_) {
				{
					GtkButton* btn = NULL;
					GtkContainer* _tmp20_ = NULL;
					GIcon* _tmp21_ = NULL;
					const gchar* _tmp22_ = NULL;
					GIcon* _tmp23_ = NULL;
					GtkButton* _tmp24_ = NULL;
					GtkWidget* _tmp25_ = NULL;
					GtkWidget* _tmp26_ = NULL;
					_tmp20_ = self->priv->button;
					btn = G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, gtk_button_get_type ()) ? ((GtkButton*) _tmp20_) : NULL;
					_tmp22_ = self->priv->_icon;
					_tmp23_ = g_icon_new_for_string (_tmp22_, &_inner_error_);
					_tmp21_ = _tmp23_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						goto __catch0_g_error;
					}
					_tmp24_ = btn;
					_tmp25_ = gtk_button_get_image (_tmp24_);
					_tmp26_ = _tmp25_;
					g_object_set (G_TYPE_CHECK_INSTANCE_TYPE (_tmp26_, gtk_image_get_type ()) ? ((GtkImage*) _tmp26_) : NULL, "gicon", _tmp21_, NULL);
					_g_object_unref0 (_tmp21_);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					FILE* _tmp27_ = NULL;
					GError* _tmp28_ = NULL;
					const gchar* _tmp29_ = NULL;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp27_ = stderr;
					_tmp28_ = e;
					_tmp29_ = _tmp28_->message;
					fprintf (_tmp27_, "%s\n", _tmp29_);
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
		}
	}
}


static void ___lambda7__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	__lambda7_ ((Menu*) self, key);
}


static void menu_real_create (PanelApplet* base) {
	Menu * self;
	GSettings* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	GSettings* _tmp2_ = NULL;
	GSettings* _tmp3_ = NULL;
	GSettings* _tmp4_ = NULL;
	GSettings* _tmp5_ = NULL;
	GSettings* _tmp6_ = NULL;
	GSettings* _tmp7_ = NULL;
	GSettings* _tmp8_ = NULL;
	GSettings* _tmp9_ = NULL;
	GSettings* _tmp10_ = NULL;
	GSettings* _tmp11_ = NULL;
	GtkContainer* w = NULL;
	GtkContainer* _tmp12_ = NULL;
	GtkContainer* _tmp13_ = NULL;
	GtkSettings* gtksettings = NULL;
	GtkSettings* _tmp14_ = NULL;
	GSettings* _tmp15_ = NULL;
	GSettings* _tmp16_ = NULL;
	self = (Menu*) base;
	self->priv->button = NULL;
	gtk_event_box_set_visible_window ((GtkEventBox*) self, FALSE);
	_tmp0_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp1_ = _tmp0_;
	g_settings_bind (_tmp1_, KEY_IS_SYSTEM_MENU, (GObject*) self, "system", G_SETTINGS_BIND_GET);
	_tmp2_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp3_ = _tmp2_;
	g_settings_bind (_tmp3_, KEY_IS_MENU_BAR, (GObject*) self, "bar", G_SETTINGS_BIND_GET);
	_tmp4_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp5_ = _tmp4_;
	g_settings_bind (_tmp5_, KEY_IS_INTERNAL_MENU, (GObject*) self, "intern", G_SETTINGS_BIND_GET);
	_tmp6_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp7_ = _tmp6_;
	g_settings_bind (_tmp7_, KEY_MODEL_FILE, (GObject*) self, "filename", G_SETTINGS_BIND_GET);
	_tmp8_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp9_ = _tmp8_;
	g_settings_bind (_tmp9_, KEY_ICON, (GObject*) self, "icon", G_SETTINGS_BIND_GET);
	_tmp10_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp11_ = _tmp10_;
	g_settings_bind (_tmp11_, KEY_CAPTION, (GObject*) self, "caption", G_SETTINGS_BIND_GET);
	_tmp12_ = menu_menumodel_widget_create (self);
	w = _tmp12_;
	self->priv->button = w;
	_tmp13_ = self->priv->button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
	_tmp14_ = gtk_widget_get_settings ((GtkWidget*) self);
	gtksettings = _tmp14_;
	g_object_set (gtksettings, "gtk-shell-shows-menubar", FALSE, NULL);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp15_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp16_ = _tmp15_;
	g_signal_connect_object (_tmp16_, "changed", (GCallback) ___lambda7__g_settings_changed, self, 0);
	_g_object_unref0 (w);
}


static void menu_menumodel_widget_rebuild (Menu* self) {
	GtkContainer* btn = NULL;
	GtkContainer* _tmp0_ = NULL;
	GtkContainer* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	menu_menumodel_widget_destroy (self);
	_tmp0_ = menu_menumodel_widget_create (self);
	btn = _tmp0_;
	self->priv->button = btn;
	_tmp1_ = self->priv->button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
	_g_object_unref0 (btn);
}


static GtkContainer* menu_menumodel_widget_create (Menu* self) {
	GtkContainer* result = NULL;
	GMenuModel* _tmp0_ = NULL;
	GMenu* _tmp1_ = NULL;
	GtkContainer* ret = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = menu_create_menumodel (self);
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_menu_get_type ()) ? ((GMenu*) _tmp0_) : NULL;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (_tmp0_);
	}
	_g_object_unref0 (self->priv->menu);
	self->priv->menu = _tmp1_;
	_tmp2_ = self->priv->_bar;
	if (_tmp2_) {
		GtkMenuBar* _tmp3_ = NULL;
		GtkContainer* _tmp4_ = NULL;
		_tmp3_ = menu_create_menubar (self);
		_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp3_) : NULL;
		if (_tmp4_ == NULL) {
			_g_object_unref0 (_tmp3_);
		}
		_g_object_unref0 (ret);
		ret = _tmp4_;
	} else {
		GtkToggleButton* _tmp5_ = NULL;
		GtkContainer* _tmp6_ = NULL;
		_tmp5_ = menu_create_menubutton (self);
		_tmp6_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp5_) : NULL;
		if (_tmp6_ == NULL) {
			_g_object_unref0 (_tmp5_);
		}
		_g_object_unref0 (ret);
		ret = _tmp6_;
	}
	result = ret;
	return result;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		Menu* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->menubar);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static void __lambda4_ (Block1Data* _data1_) {
	Menu* self;
	GtkPackDirection _tmp0_ = 0;
	ValaPanelToplevel* _tmp1_ = NULL;
	ValaPanelToplevel* _tmp2_ = NULL;
	GtkOrientation _tmp3_ = 0;
	GtkOrientation _tmp4_ = 0;
	GtkMenuBar* _tmp5_ = NULL;
	self = _data1_->self;
	_tmp1_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_panel_toplevel_get_orientation (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == GTK_ORIENTATION_HORIZONTAL) {
		_tmp0_ = GTK_PACK_DIRECTION_LTR;
	} else {
		_tmp0_ = GTK_PACK_DIRECTION_TTB;
	}
	_data1_->orient = _tmp0_;
	_tmp5_ = _data1_->menubar;
	gtk_menu_bar_set_pack_direction (_tmp5_, _data1_->orient);
}


static void ___lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda4_ (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GtkMenuBar* menu_create_menubar (Menu* self) {
	GtkMenuBar* result = NULL;
	Block1Data* _data1_;
	GMenu* _tmp0_ = NULL;
	GtkMenuBar* _tmp1_ = NULL;
	GtkMenuBar* _tmp2_ = NULL;
	GList* _tmp3_ = NULL;
	GList* _tmp4_ = NULL;
	GMenu* _tmp5_ = NULL;
	GtkMenuBar* _tmp6_ = NULL;
	GtkMenuBar* _tmp7_ = NULL;
	GtkPackDirection _tmp8_ = 0;
	ValaPanelToplevel* _tmp9_ = NULL;
	ValaPanelToplevel* _tmp10_ = NULL;
	GtkOrientation _tmp11_ = 0;
	GtkOrientation _tmp12_ = 0;
	GtkMenuBar* _tmp13_ = NULL;
	ValaPanelToplevel* _tmp14_ = NULL;
	ValaPanelToplevel* _tmp15_ = NULL;
	GtkMenuBar* _tmp16_ = NULL;
	GtkMenuBar* _tmp17_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	self->priv->int_menu = NULL;
	_tmp0_ = self->priv->menu;
	_tmp1_ = (GtkMenuBar*) gtk_menu_bar_new_from_model ((GMenuModel*) _tmp0_);
	g_object_ref_sink (_tmp1_);
	_data1_->menubar = _tmp1_;
	_tmp2_ = _data1_->menubar;
	_tmp3_ = gtk_container_get_children ((GtkContainer*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = self->priv->menu;
	apply_menu_properties (_tmp4_, (GMenuModel*) _tmp5_);
	_g_list_free0 (_tmp4_);
	_tmp6_ = _data1_->menubar;
	vala_panel_applet_set_background_widget ((PanelApplet*) self, (GtkWidget*) _tmp6_);
	vala_panel_applet_init_background ((PanelApplet*) self);
	_tmp7_ = _data1_->menubar;
	gtk_widget_show ((GtkWidget*) _tmp7_);
	_tmp9_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
	_tmp10_ = _tmp9_;
	_tmp11_ = vala_panel_toplevel_get_orientation (_tmp10_);
	_tmp12_ = _tmp11_;
	if (_tmp12_ == GTK_ORIENTATION_HORIZONTAL) {
		_tmp8_ = GTK_PACK_DIRECTION_LTR;
	} else {
		_tmp8_ = GTK_PACK_DIRECTION_TTB;
	}
	_data1_->orient = _tmp8_;
	_tmp13_ = _data1_->menubar;
	gtk_menu_bar_set_pack_direction (_tmp13_, _data1_->orient);
	_tmp14_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
	_tmp15_ = _tmp14_;
	g_signal_connect_data ((GObject*) _tmp15_, "notify::edge", (GCallback) ___lambda4__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp16_ = _data1_->menubar;
	_tmp17_ = _g_object_ref0 (_tmp16_);
	result = _tmp17_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		Menu* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->menubutton);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static void __lambda5_ (Block2Data* _data2_) {
	Menu* self;
	GtkToggleButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	self = _data2_->self;
	_tmp0_ = _data2_->menubutton;
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkMenu* _tmp3_ = NULL;
		guint32 _tmp4_ = 0U;
		_tmp3_ = self->priv->int_menu;
		_tmp4_ = gtk_get_current_event_time ();
		gtk_menu_popup (_tmp3_, NULL, NULL, _vala_panel_applet_menu_position_func_gtk_menu_position_func, g_object_ref ((PanelApplet*) self), (guint) 0, _tmp4_);
	} else {
		GtkMenu* _tmp5_ = NULL;
		_tmp5_ = self->priv->int_menu;
		gtk_menu_popdown (_tmp5_);
	}
}


static void ___lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda5_ (self);
}


static void __lambda6_ (Block2Data* _data2_) {
	Menu* self;
	GtkToggleButton* _tmp0_ = NULL;
	self = _data2_->self;
	_tmp0_ = _data2_->menubutton;
	gtk_toggle_button_set_active (_tmp0_, FALSE);
}


static void ___lambda6__gtk_widget_hide (GtkWidget* _sender, gpointer self) {
	__lambda6_ (self);
}


static GtkToggleButton* menu_create_menubutton (Menu* self) {
	GtkToggleButton* result = NULL;
	Block2Data* _data2_;
	GtkImage* img = NULL;
	GtkToggleButton* _tmp0_ = NULL;
	GtkMenu* menuw = NULL;
	GMenu* _tmp1_ = NULL;
	GtkMenu* _tmp2_ = NULL;
	GtkMenu* _tmp3_ = NULL;
	GtkMenu* _tmp4_ = NULL;
	GList* _tmp5_ = NULL;
	GList* _tmp6_ = NULL;
	GMenu* _tmp7_ = NULL;
	GtkMenu* _tmp8_ = NULL;
	GtkMenu* _tmp9_ = NULL;
	GtkToggleButton* _tmp10_ = NULL;
	GtkToggleButton* _tmp11_ = NULL;
	GtkMenu* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	GtkToggleButton* _tmp25_ = NULL;
	GtkImage* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	GtkToggleButton* _tmp28_ = NULL;
	GtkToggleButton* _tmp29_ = NULL;
	GtkToggleButton* _tmp30_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	img = NULL;
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp0_);
	_data2_->menubutton = _tmp0_;
	_tmp1_ = self->priv->menu;
	_tmp2_ = (GtkMenu*) gtk_menu_new_from_model ((GMenuModel*) _tmp1_);
	g_object_ref_sink (_tmp2_);
	menuw = _tmp2_;
	_tmp3_ = menuw;
	self->priv->int_menu = _tmp3_;
	_tmp4_ = self->priv->int_menu;
	_tmp5_ = gtk_container_get_children ((GtkContainer*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = self->priv->menu;
	apply_menu_properties (_tmp6_, (GMenuModel*) _tmp7_);
	_g_list_free0 (_tmp6_);
	_tmp8_ = self->priv->int_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp8_);
	_tmp9_ = self->priv->int_menu;
	_tmp10_ = _data2_->menubutton;
	gtk_menu_attach_to_widget (_tmp9_, (GtkWidget*) _tmp10_, NULL);
	_tmp11_ = _data2_->menubutton;
	g_signal_connect_data (_tmp11_, "toggled", (GCallback) ___lambda5__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp12_ = self->priv->int_menu;
	g_signal_connect_data ((GtkWidget*) _tmp12_, "hide", (GCallback) ___lambda6__gtk_widget_hide, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp13_ = self->priv->_icon;
	if (_tmp13_ != NULL) {
		GtkImage* _tmp14_ = NULL;
		GtkImage* _tmp24_ = NULL;
		_tmp14_ = (GtkImage*) gtk_image_new ();
		g_object_ref_sink (_tmp14_);
		_g_object_unref0 (img);
		img = _tmp14_;
		{
			GIcon* gicon = NULL;
			const gchar* _tmp15_ = NULL;
			GIcon* _tmp16_ = NULL;
			GtkImage* _tmp17_ = NULL;
			GIcon* _tmp18_ = NULL;
			ValaPanelToplevel* _tmp19_ = NULL;
			ValaPanelToplevel* _tmp20_ = NULL;
			_tmp15_ = self->priv->_icon;
			_tmp16_ = g_icon_new_for_string (_tmp15_, &_inner_error_);
			gicon = _tmp16_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch1_g_error;
			}
			_tmp17_ = img;
			_tmp18_ = gicon;
			_tmp19_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
			_tmp20_ = _tmp19_;
			vala_panel_setup_icon (_tmp17_, _tmp18_, _tmp20_, -1);
			_g_object_unref0 (gicon);
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			FILE* _tmp21_ = NULL;
			GError* _tmp22_ = NULL;
			const gchar* _tmp23_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp21_ = stderr;
			_tmp22_ = e;
			_tmp23_ = _tmp22_->message;
			fprintf (_tmp21_, "%s\n", _tmp23_);
			_g_error_free0 (e);
		}
		__finally1:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (menuw);
			_g_object_unref0 (img);
			block2_data_unref (_data2_);
			_data2_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp24_ = img;
		gtk_widget_show ((GtkWidget*) _tmp24_);
	}
	_tmp25_ = _data2_->menubutton;
	_tmp26_ = img;
	_tmp27_ = self->priv->_caption;
	vala_panel_setup_button (G_TYPE_CHECK_INSTANCE_TYPE (_tmp25_, gtk_button_get_type ()) ? ((GtkButton*) _tmp25_) : NULL, _tmp26_, _tmp27_);
	_tmp28_ = _data2_->menubutton;
	gtk_widget_show ((GtkWidget*) _tmp28_);
	_tmp29_ = _data2_->menubutton;
	_tmp30_ = _g_object_ref0 (_tmp29_);
	result = _tmp30_;
	_g_object_unref0 (menuw);
	_g_object_unref0 (img);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}


static void menu_menumodel_widget_destroy (Menu* self) {
	GtkMenu* _tmp0_ = NULL;
	GtkContainer* _tmp2_ = NULL;
	GAppInfoMonitor* _tmp4_ = NULL;
	GFileMonitor* _tmp6_ = NULL;
	g_return_if_fail (self != NULL);
	vala_panel_applet_set_background_widget ((PanelApplet*) self, (GtkWidget*) self);
	_tmp0_ = self->priv->int_menu;
	if (_tmp0_ != NULL) {
		GtkMenu* _tmp1_ = NULL;
		_tmp1_ = self->priv->int_menu;
		gtk_widget_destroy ((GtkWidget*) _tmp1_);
		self->priv->int_menu = NULL;
	}
	_tmp2_ = self->priv->button;
	if (_tmp2_ != NULL) {
		GtkContainer* _tmp3_ = NULL;
		_tmp3_ = self->priv->button;
		gtk_widget_destroy ((GtkWidget*) _tmp3_);
		self->priv->button = NULL;
	}
	_tmp4_ = self->priv->app_monitor;
	if (_tmp4_ != NULL) {
		GAppInfoMonitor* _tmp5_ = NULL;
		_tmp5_ = self->priv->app_monitor;
		g_signal_handlers_disconnect_by_data ((GObject*) _tmp5_, self);
		_g_object_unref0 (self->priv->app_monitor);
		self->priv->app_monitor = NULL;
	}
	_tmp6_ = self->priv->file_monitor;
	if (_tmp6_ != NULL) {
		GFileMonitor* _tmp7_ = NULL;
		_tmp7_ = self->priv->file_monitor;
		g_signal_handlers_disconnect_by_data ((GObject*) _tmp7_, self);
		_g_object_unref0 (self->priv->file_monitor);
		self->priv->file_monitor = NULL;
	}
}


static void _menu_menumodel_widget_rebuild_g_app_info_monitor_changed (GAppInfoMonitor* _sender, gpointer self) {
	menu_menumodel_widget_rebuild ((Menu*) self);
}


static void _menu_menumodel_widget_rebuild_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
	menu_menumodel_widget_rebuild ((Menu*) self);
}


static GMenuModel* menu_create_menumodel (Menu* self) {
	GMenuModel* result = NULL;
	GMenuModel* ret = NULL;
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_intern;
	if (_tmp0_) {
		gboolean _tmp1_ = FALSE;
		const gchar* _tmp2_ = NULL;
		GMenuModel* _tmp3_ = NULL;
		GAppInfoMonitor* _tmp4_ = NULL;
		GAppInfoMonitor* _tmp5_ = NULL;
		_tmp1_ = self->priv->_bar;
		_tmp2_ = self->priv->_icon;
		_tmp3_ = menu_maker_create_main_menu (_tmp1_, _tmp2_);
		_g_object_unref0 (ret);
		ret = _tmp3_;
		_tmp4_ = g_app_info_monitor_get ();
		_g_object_unref0 (self->priv->app_monitor);
		self->priv->app_monitor = _tmp4_;
		_tmp5_ = self->priv->app_monitor;
		g_signal_connect_object (_tmp5_, "changed", (GCallback) _menu_menumodel_widget_rebuild_g_app_info_monitor_changed, self, 0);
		_g_object_unref0 (self->priv->file_monitor);
		self->priv->file_monitor = NULL;
	} else {
		const gchar* _tmp6_ = NULL;
		GFile* f = NULL;
		const gchar* _tmp7_ = NULL;
		GFile* _tmp8_ = NULL;
		GMenuModel* _tmp9_ = NULL;
		GFileMonitor* _tmp17_ = NULL;
		_tmp6_ = self->priv->_filename;
		if (_tmp6_ == NULL) {
			result = NULL;
			_g_object_unref0 (ret);
			return result;
		}
		_tmp7_ = self->priv->_filename;
		_tmp8_ = g_file_new_for_path (_tmp7_);
		f = _tmp8_;
		_tmp9_ = menu_read_menumodel (self);
		_g_object_unref0 (ret);
		ret = _tmp9_;
		{
			GFileMonitor* _tmp10_ = NULL;
			GFile* _tmp11_ = NULL;
			GFileMonitor* _tmp12_ = NULL;
			GFileMonitor* _tmp13_ = NULL;
			_tmp11_ = f;
			_tmp12_ = g_file_monitor_file (_tmp11_, G_FILE_MONITOR_SEND_MOVED | G_FILE_MONITOR_WATCH_HARD_LINKS, NULL, &_inner_error_);
			_tmp10_ = _tmp12_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch2_g_error;
			}
			_tmp13_ = _tmp10_;
			_tmp10_ = NULL;
			_g_object_unref0 (self->priv->file_monitor);
			self->priv->file_monitor = _tmp13_;
			_g_object_unref0 (_tmp10_);
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			FILE* _tmp14_ = NULL;
			GError* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp14_ = stderr;
			_tmp15_ = e;
			_tmp16_ = _tmp15_->message;
			fprintf (_tmp14_, "%s\n", _tmp16_);
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (f);
			_g_object_unref0 (ret);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp17_ = self->priv->file_monitor;
		g_signal_connect_object (_tmp17_, "changed", (GCallback) _menu_menumodel_widget_rebuild_g_file_monitor_changed, self, 0);
		_g_object_unref0 (self->priv->app_monitor);
		self->priv->app_monitor = NULL;
		_g_object_unref0 (f);
	}
	result = ret;
	return result;
}


static GMenuModel* menu_read_menumodel (Menu* self) {
	GMenuModel* result = NULL;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_builder_new ();
	builder = _tmp0_;
	{
		const gchar* _tmp1_ = NULL;
		GMenu* ret = NULL;
		GObject* _tmp2_ = NULL;
		GMenu* gotten = NULL;
		GObject* _tmp3_ = NULL;
		GMenu* _tmp4_ = NULL;
		GObject* _tmp6_ = NULL;
		GMenu* _tmp7_ = NULL;
		GObject* _tmp9_ = NULL;
		GMenu* _tmp10_ = NULL;
		GObject* _tmp12_ = NULL;
		GMenu* _tmp13_ = NULL;
		GMenu* _tmp15_ = NULL;
		GMenuModel* _tmp16_ = NULL;
		_tmp1_ = self->priv->_filename;
		gtk_builder_add_from_file (builder, _tmp1_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch3_g_error;
		}
		_tmp2_ = gtk_builder_get_object (builder, "vala-panel-menu");
		ret = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_menu_get_type ()) ? ((GMenu*) _tmp2_) : NULL;
		_tmp3_ = gtk_builder_get_object (builder, "vala-panel-internal-applications");
		gotten = G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, g_menu_get_type ()) ? ((GMenu*) _tmp3_) : NULL;
		_tmp4_ = gotten;
		if (_tmp4_ != NULL) {
			GMenu* _tmp5_ = NULL;
			_tmp5_ = gotten;
			menu_load_internal_menus (_tmp5_, INTERNAL_MENU_APPLICATIONS);
		}
		_tmp6_ = gtk_builder_get_object (builder, "vala-panel-internal-settings");
		gotten = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, g_menu_get_type ()) ? ((GMenu*) _tmp6_) : NULL;
		_tmp7_ = gotten;
		if (_tmp7_ != NULL) {
			GMenu* _tmp8_ = NULL;
			_tmp8_ = gotten;
			menu_load_internal_menus (_tmp8_, INTERNAL_MENU_SETTINGS);
		}
		_tmp9_ = gtk_builder_get_object (builder, "vala-panel-internal-mounts");
		gotten = G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, g_menu_get_type ()) ? ((GMenu*) _tmp9_) : NULL;
		_tmp10_ = gotten;
		if (_tmp10_ != NULL) {
			GMenu* _tmp11_ = NULL;
			_tmp11_ = gotten;
			menu_load_internal_menus (_tmp11_, INTERNAL_MENU_MOUNTS);
		}
		_tmp12_ = gtk_builder_get_object (builder, "vala-panel-internal-recent");
		gotten = G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, g_menu_get_type ()) ? ((GMenu*) _tmp12_) : NULL;
		_tmp13_ = gotten;
		if (_tmp13_ != NULL) {
			GMenu* _tmp14_ = NULL;
			_tmp14_ = gotten;
			menu_load_internal_menus (_tmp14_, INTERNAL_MENU_RECENT);
		}
		_tmp15_ = ret;
		_tmp16_ = _g_object_ref0 ((GMenuModel*) _tmp15_);
		result = _tmp16_;
		_g_object_unref0 (builder);
		return result;
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		FILE* _tmp17_ = NULL;
		GError* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp17_ = stderr;
		_tmp18_ = e;
		_tmp19_ = _tmp18_->message;
		fprintf (_tmp17_, "%s", _tmp19_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = NULL;
	_g_object_unref0 (builder);
	return result;
}


static void menu_load_internal_menus (GMenu* int_menu, InternalMenu req) {
	GMenuModel* section = NULL;
	InternalMenu _tmp0_ = 0;
	g_return_if_fail (int_menu != NULL);
	_tmp0_ = req;
	switch (_tmp0_) {
		case INTERNAL_MENU_APPLICATIONS:
		{
			GMenuModel* _tmp1_ = NULL;
			GMenu* _tmp2_ = NULL;
			GMenuModel* _tmp3_ = NULL;
			_tmp1_ = menu_maker_create_applications_menu (FALSE);
			_g_object_unref0 (section);
			section = _tmp1_;
			_tmp2_ = int_menu;
			_tmp3_ = section;
			g_menu_append_section (_tmp2_, NULL, _tmp3_);
			break;
		}
		case INTERNAL_MENU_SETTINGS:
		{
			GMenuModel* _tmp4_ = NULL;
			GMenu* _tmp5_ = NULL;
			GMenuModel* _tmp6_ = NULL;
			_tmp4_ = menu_maker_create_applications_menu (TRUE);
			_g_object_unref0 (section);
			section = _tmp4_;
			_tmp5_ = int_menu;
			_tmp6_ = section;
			g_menu_append_section (_tmp5_, NULL, _tmp6_);
			break;
		}
		default:
		break;
	}
	_g_object_unref0 (section);
}


const gchar* menu_get_icon (Menu* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon;
	result = _tmp0_;
	return result;
}


void menu_set_icon (Menu* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_icon);
	self->priv->_icon = _tmp1_;
	g_object_notify ((GObject *) self, "icon");
}


gboolean menu_get_system (Menu* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_system;
	result = _tmp0_;
	return result;
}


void menu_set_system (Menu* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_system = _tmp0_;
	g_object_notify ((GObject *) self, "system");
}


gboolean menu_get_intern (Menu* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_intern;
	result = _tmp0_;
	return result;
}


void menu_set_intern (Menu* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_intern = _tmp0_;
	g_object_notify ((GObject *) self, "intern");
}


gboolean menu_get_bar (Menu* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_bar;
	result = _tmp0_;
	return result;
}


void menu_set_bar (Menu* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_bar = _tmp0_;
	g_object_notify ((GObject *) self, "bar");
}


const gchar* menu_get_caption (Menu* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_caption;
	result = _tmp0_;
	return result;
}


void menu_set_caption (Menu* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_caption);
	self->priv->_caption = _tmp1_;
	g_object_notify ((GObject *) self, "caption");
}


const gchar* menu_get_filename (Menu* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_filename;
	result = _tmp0_;
	return result;
}


void menu_set_filename (Menu* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_filename);
	self->priv->_filename = _tmp1_;
	g_object_notify ((GObject *) self, "filename");
}


static void menu_class_init (MenuClass * klass) {
	menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MenuPrivate));
	((GtkWidgetClass *) klass)->destroy = menu_real_destroy;
	((PanelAppletClass *) klass)->create = menu_real_create;
	G_OBJECT_CLASS (klass)->get_property = _vala_menu_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_menu_set_property;
	G_OBJECT_CLASS (klass)->finalize = menu_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_ICON, g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_SYSTEM, g_param_spec_boolean ("system", "system", "system", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_INTERN, g_param_spec_boolean ("intern", "intern", "intern", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR, g_param_spec_boolean ("bar", "bar", "bar", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_CAPTION, g_param_spec_string ("caption", "caption", "caption", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_FILENAME, g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void menu_vala_panel_applet_configurable_interface_init (ValaPanelAppletConfigurableIface * iface) {
	menu_vala_panel_applet_configurable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_config_dialog = (GtkDialog* (*)(ValaPanelAppletConfigurable*)) menu_real_get_config_dialog;
}


static void menu_vala_panel_applet_menu_interface_init (ValaPanelAppletMenuIface * iface) {
	menu_vala_panel_applet_menu_parent_iface = g_type_interface_peek_parent (iface);
	iface->show_system_menu = (void (*)(ValaPanelAppletMenu*)) menu_real_show_system_menu;
}


static void menu_instance_init (Menu * self) {
	self->priv = MENU_GET_PRIVATE (self);
}


static void menu_finalize (GObject* obj) {
	Menu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU, Menu);
	_g_object_unref0 (self->priv->menu);
	_g_object_unref0 (self->priv->app_monitor);
	_g_object_unref0 (self->priv->file_monitor);
	_g_free0 (self->priv->_icon);
	_g_free0 (self->priv->_caption);
	_g_free0 (self->priv->_filename);
	G_OBJECT_CLASS (menu_parent_class)->finalize (obj);
}


GType menu_get_type (void) {
	return menu_type_id;
}


GType menu_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Menu), 0, (GInstanceInitFunc) menu_instance_init, NULL };
	static const GInterfaceInfo vala_panel_applet_configurable_info = { (GInterfaceInitFunc) menu_vala_panel_applet_configurable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo vala_panel_applet_menu_info = { (GInterfaceInitFunc) menu_vala_panel_applet_menu_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	menu_type_id = g_type_module_register_type (module, VALA_PANEL_TYPE_APPLET, "Menu", &g_define_type_info, 0);
	g_type_module_add_interface (module, menu_type_id, VALA_PANEL_TYPE_APPLET_CONFIGURABLE, &vala_panel_applet_configurable_info);
	g_type_module_add_interface (module, menu_type_id, VALA_PANEL_TYPE_APPLET_MENU, &vala_panel_applet_menu_info);
	return menu_type_id;
}


static void _vala_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Menu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU, Menu);
	switch (property_id) {
		case MENU_ICON:
		g_value_set_string (value, menu_get_icon (self));
		break;
		case MENU_SYSTEM:
		g_value_set_boolean (value, menu_get_system (self));
		break;
		case MENU_INTERN:
		g_value_set_boolean (value, menu_get_intern (self));
		break;
		case MENU_BAR:
		g_value_set_boolean (value, menu_get_bar (self));
		break;
		case MENU_CAPTION:
		g_value_set_string (value, menu_get_caption (self));
		break;
		case MENU_FILENAME:
		g_value_set_string (value, menu_get_filename (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Menu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU, Menu);
	switch (property_id) {
		case MENU_ICON:
		menu_set_icon (self, g_value_get_string (value));
		break;
		case MENU_SYSTEM:
		menu_set_system (self, g_value_get_boolean (value));
		break;
		case MENU_INTERN:
		menu_set_intern (self, g_value_get_boolean (value));
		break;
		case MENU_BAR:
		menu_set_bar (self, g_value_get_boolean (value));
		break;
		case MENU_CAPTION:
		menu_set_caption (self, g_value_get_string (value));
		break;
		case MENU_FILENAME:
		menu_set_filename (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


void peas_register_types (GTypeModule* module) {
	PeasObjectModule* objmodule = NULL;
	GTypeModule* _tmp0_ = NULL;
	PeasObjectModule* _tmp1_ = NULL;
	g_return_if_fail (module != NULL);
	menu_applet_register_type (module);
	menu_register_type (module);
	_tmp0_ = module;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, peas_object_module_get_type ()) ? ((PeasObjectModule*) _tmp0_) : NULL);
	objmodule = _tmp1_;
	peas_object_module_register_extension_type (objmodule, VALA_PANEL_TYPE_APPLET_PLUGIN, TYPE_MENU_APPLET);
	_g_object_unref0 (objmodule);
}



