/* monitors.c generated by valac 0.32.1, the Vala compiler
 * generated from monitors.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <libpeas/peas.h>
#include <vala-panel-compat.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <lib/launcher.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>
#include <errno.h>
#include <lib/generic-config-dialog.h>


#define TYPE_MONITORS_APPLET (monitors_applet_get_type ())
#define MONITORS_APPLET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORS_APPLET, MonitorsApplet))
#define MONITORS_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MONITORS_APPLET, MonitorsAppletClass))
#define IS_MONITORS_APPLET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORS_APPLET))
#define IS_MONITORS_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MONITORS_APPLET))
#define MONITORS_APPLET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MONITORS_APPLET, MonitorsAppletClass))

typedef struct _MonitorsApplet MonitorsApplet;
typedef struct _MonitorsAppletClass MonitorsAppletClass;
typedef struct _MonitorsAppletPrivate MonitorsAppletPrivate;

#define TYPE_MONITORS (monitors_get_type ())
#define MONITORS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORS, Monitors))
#define MONITORS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MONITORS, MonitorsClass))
#define IS_MONITORS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORS))
#define IS_MONITORS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MONITORS))
#define MONITORS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MONITORS, MonitorsClass))

typedef struct _Monitors Monitors;
typedef struct _MonitorsClass MonitorsClass;

#define TYPE_MONITOR_TYPE (monitor_type_get_type ())
typedef struct _Monitor Monitor;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _monitor_unref0(var) ((var == NULL) ? NULL : (var = (monitor_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef Monitor CpuMonitor;

#define CPU_MONITOR_TYPE_CPU_STAT (cpu_monitor_cpu_stat_get_type ())
typedef struct _CpuMonitorcpu_stat CpuMonitorcpu_stat;
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef Monitor MemMonitor;
typedef struct _MonitorsPrivate MonitorsPrivate;

struct _MonitorsApplet {
	PeasExtensionBase parent_instance;
	MonitorsAppletPrivate * priv;
};

struct _MonitorsAppletClass {
	PeasExtensionBaseClass parent_class;
};

typedef enum  {
	MONITOR_TYPE_CPU = 0,
	MONITOR_TYPE_RAM = 1,
	MONITOR_TYPE_N_MONS = 2
} MonitorType;

typedef gboolean (*MonitorUpdateMonitorFunc) (Monitor* m);
typedef void (*MonitorUpdateTooltipFunc) (Monitor* m);
struct _Monitor {
	GdkRGBA foreground_color;
	GtkDrawingArea* da;
	cairo_surface_t* pixmap;
	gint pixmap_width;
	gint pixmap_height;
	gdouble* stats;
	gint stats_length1;
	gint _stats_size_;
	gdouble total;
	gint ring_cursor;
	gint position;
	volatile int ref_count;
	MonitorUpdateMonitorFunc update_monitor;
	MonitorUpdateTooltipFunc update_tooltip;
};

struct _Block1Data {
	int _ref_count_;
	Monitor* self;
	Monitors* plugin;
};

struct _CpuMonitorcpu_stat {
	gint64 u;
	gint64 n;
	gint64 s;
	gint64 i;
};

struct _Monitors {
	PanelApplet parent_instance;
	MonitorsPrivate * priv;
};

struct _MonitorsClass {
	PanelAppletClass parent_class;
};

struct _MonitorsPrivate {
	Monitor** monitors;
	gint monitors_length1;
	gint _monitors_size_;
	gboolean* displayed_mons;
	gint displayed_mons_length1;
	gint _displayed_mons_size_;
	GtkBox* box;
	guint timer;
};


static gpointer monitors_applet_parent_class = NULL;
static ValaPanelAppletPluginIface* monitors_applet_vala_panel_applet_plugin_parent_iface = NULL;
static GType monitors_applet_type_id = 0;
static gpointer monitors_parent_class = NULL;
static ValaPanelAppletConfigurableIface* monitors_vala_panel_applet_configurable_parent_iface = NULL;
static GType monitors_type_id = 0;

GType monitors_applet_get_type (void) G_GNUC_CONST;
GType monitors_applet_register_type (GTypeModule * module);
enum  {
	MONITORS_APPLET_DUMMY_PROPERTY
};
static PanelApplet* monitors_applet_real_get_applet_widget (ValaPanelAppletPlugin* base, ValaPanelToplevel* toplevel, GSettings* settings, guint number);
Monitors* monitors_new (ValaPanelToplevel* toplevel, GSettings* settings, guint number);
Monitors* monitors_construct (GType object_type, ValaPanelToplevel* toplevel, GSettings* settings, guint number);
GType monitors_get_type (void) G_GNUC_CONST;
GType monitors_register_type (GTypeModule * module);
MonitorsApplet* monitors_applet_new (void);
MonitorsApplet* monitors_applet_construct (GType object_type);
GType monitor_type_get_type (void) G_GNUC_CONST;
void monitor_free (Monitor* self);
static void monitor_instance_init (Monitor * self);
#define MONITOR_DEFAULT_WIDTH 40
#define MONITOR_BORDER_SIZE 2
gboolean monitor_update (Monitor* self);
Monitor* monitor_new (Monitors* plugin, const gchar* color);
Monitor* monitor_new (Monitors* plugin, const gchar* color);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda4_ (Monitor* self, GdkEventConfigure* e);
static gdouble* _vala_array_dup1 (gdouble* self, int length);
void monitor_redraw_pixmap (Monitor* self);
static gboolean ___lambda4__gtk_widget_configure_event (GtkWidget* _sender, GdkEventConfigure* event, gpointer self);
static gboolean __lambda5_ (Monitor* self, cairo_t* cr);
static gboolean ___lambda5__gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static gboolean __lambda6_ (Block1Data* _data1_, GdkEventButton* e);
#define MONITORS_ACTION "click-action"
static gboolean ___lambda6__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
Monitor* monitor_ref (Monitor* self);
void monitor_unref (Monitor* self);
void monitor_free (Monitor* self);
CpuMonitor* cpu_monitor_new (Monitors* plugin, const gchar* color);
CpuMonitor* cpu_monitor_new (Monitors* plugin, const gchar* color);
gboolean cpu_monitor_update_cpu (Monitor* c);
static gboolean _cpu_monitor_update_cpu_monitor_update_monitor_func (Monitor* m);
void cpu_monitor_tooltip_update_cpu (Monitor* m);
static void _cpu_monitor_tooltip_update_cpu_monitor_update_tooltip_func (Monitor* m);
static GType cpu_monitor_cpu_stat_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static CpuMonitorcpu_stat* cpu_monitor_cpu_stat_dup (const CpuMonitorcpu_stat* self);
static void cpu_monitor_cpu_stat_free (CpuMonitorcpu_stat* self);
MemMonitor* mem_monitor_new (Monitors* plugin, const gchar* color);
MemMonitor* mem_monitor_new (Monitors* plugin, const gchar* color);
gboolean mem_monitor_update_mem (Monitor* m);
static gboolean _mem_monitor_update_mem_monitor_update_monitor_func (Monitor* m);
void mem_monitor_tooltip_update_mem (Monitor* m);
static void _mem_monitor_tooltip_update_mem_monitor_update_tooltip_func (Monitor* m);
#define MONITORS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MONITORS, MonitorsPrivate))
enum  {
	MONITORS_DUMMY_PROPERTY
};
#define MONITORS_UPDATE_PERIOD ((guint) 1)
#define MONITORS_N_MONITORS ((guint) 2)
#define MONITORS_DISPLAY_CPU "display-cpu-monitor"
#define MONITORS_DISPLAY_RAM "display-ram-monitor"
#define MONITORS_CPU_CL "cpu-color"
#define MONITORS_RAM_CL "ram-color"
static GtkDialog* monitors_real_get_config_dialog (ValaPanelAppletConfigurable* base);
static void monitors_real_create (PanelApplet* base);
static Monitor* monitors_create_monitor (Monitors* self, MonitorType type);
static gboolean monitors_monitors_update (Monitors* self);
static gboolean _monitors_monitors_update_gsource_func (gpointer self);
static void __lambda7_ (Monitors* self, const gchar* key);
static void monitors_rebuild_mons (Monitors* self);
static void ___lambda7__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
static void __lambda8_ (Monitors* self);
static void ___lambda8__gtk_widget_destroy (GtkWidget* _sender, gpointer self);
static void monitors_finalize (GObject* obj);
void peas_register_types (GTypeModule* module);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static PanelApplet* monitors_applet_real_get_applet_widget (ValaPanelAppletPlugin* base, ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	MonitorsApplet * self;
	PanelApplet* result = NULL;
	ValaPanelToplevel* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	Monitors* _tmp3_ = NULL;
	self = (MonitorsApplet*) base;
	g_return_val_if_fail (toplevel != NULL, NULL);
	_tmp0_ = toplevel;
	_tmp1_ = settings;
	_tmp2_ = number;
	_tmp3_ = monitors_new (_tmp0_, _tmp1_, _tmp2_);
	g_object_ref_sink (_tmp3_);
	result = (PanelApplet*) _tmp3_;
	return result;
}


MonitorsApplet* monitors_applet_construct (GType object_type) {
	MonitorsApplet * self = NULL;
	self = (MonitorsApplet*) g_object_new (object_type, NULL);
	return self;
}


MonitorsApplet* monitors_applet_new (void) {
	return monitors_applet_construct (TYPE_MONITORS_APPLET);
}


static void monitors_applet_class_init (MonitorsAppletClass * klass) {
	monitors_applet_parent_class = g_type_class_peek_parent (klass);
}


static void monitors_applet_vala_panel_applet_plugin_interface_init (ValaPanelAppletPluginIface * iface) {
	monitors_applet_vala_panel_applet_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_applet_widget = (PanelApplet* (*)(ValaPanelAppletPlugin*, ValaPanelToplevel*, GSettings*, guint)) monitors_applet_real_get_applet_widget;
}


static void monitors_applet_instance_init (MonitorsApplet * self) {
}


GType monitors_applet_get_type (void) {
	return monitors_applet_type_id;
}


GType monitors_applet_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MonitorsAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) monitors_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MonitorsApplet), 0, (GInstanceInitFunc) monitors_applet_instance_init, NULL };
	static const GInterfaceInfo vala_panel_applet_plugin_info = { (GInterfaceInitFunc) monitors_applet_vala_panel_applet_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	monitors_applet_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "MonitorsApplet", &g_define_type_info, 0);
	g_type_module_add_interface (module, monitors_applet_type_id, VALA_PANEL_TYPE_APPLET_PLUGIN, &vala_panel_applet_plugin_info);
	return monitors_applet_type_id;
}


GType monitor_type_get_type (void) {
	static volatile gsize monitor_type_type_id__volatile = 0;
	if (g_once_init_enter (&monitor_type_type_id__volatile)) {
		static const GEnumValue values[] = {{MONITOR_TYPE_CPU, "MONITOR_TYPE_CPU", "cpu"}, {MONITOR_TYPE_RAM, "MONITOR_TYPE_RAM", "ram"}, {MONITOR_TYPE_N_MONS, "MONITOR_TYPE_N_MONS", "n-mons"}, {0, NULL, NULL}};
		GType monitor_type_type_id;
		monitor_type_type_id = g_enum_register_static ("MonitorType", values);
		g_once_init_leave (&monitor_type_type_id__volatile, monitor_type_type_id);
	}
	return monitor_type_type_id__volatile;
}


gboolean monitor_update (Monitor* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	MonitorUpdateTooltipFunc _tmp1_ = NULL;
	MonitorUpdateMonitorFunc _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->update_tooltip;
	if (_tmp1_ != NULL) {
		GtkDrawingArea* _tmp2_ = NULL;
		_tmp2_ = self->da;
		_tmp0_ = _tmp2_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		MonitorUpdateTooltipFunc _tmp3_ = NULL;
		_tmp3_ = self->update_tooltip;
		_tmp3_ (self);
	}
	_tmp4_ = self->update_monitor;
	_tmp5_ = _tmp4_ (self);
	result = _tmp5_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		Monitor* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->plugin);
		_monitor_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static gdouble* _vala_array_dup1 (gdouble* self, int length) {
	return g_memdup (self, length * sizeof (gdouble));
}


static gboolean __lambda4_ (Monitor* self, GdkEventConfigure* e) {
	gboolean result = FALSE;
	GtkAllocation allocation = {0};
	gint new_pixmap_width = 0;
	gint new_pixmap_height = 0;
	GtkDrawingArea* _tmp0_ = NULL;
	GtkAllocation _tmp1_ = {0};
	GtkAllocation _tmp2_ = {0};
	gint _tmp3_ = 0;
	GtkAllocation _tmp4_ = {0};
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_ = 0;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = self->da;
	gtk_widget_get_allocation ((GtkWidget*) _tmp0_, &_tmp1_);
	allocation = _tmp1_;
	_tmp2_ = allocation;
	_tmp3_ = _tmp2_.width;
	new_pixmap_width = _tmp3_ - (MONITOR_BORDER_SIZE * 2);
	_tmp4_ = allocation;
	_tmp5_ = _tmp4_.height;
	new_pixmap_height = _tmp5_ - (MONITOR_BORDER_SIZE * 2);
	_tmp7_ = new_pixmap_width;
	if (_tmp7_ > 0) {
		gint _tmp8_ = 0;
		_tmp8_ = new_pixmap_height;
		_tmp6_ = _tmp8_ > 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gboolean _tmp9_ = FALSE;
		gdouble* _tmp10_ = NULL;
		gint _tmp10__length1 = 0;
		gint _tmp54_ = 0;
		gint _tmp55_ = 0;
		gint _tmp56_ = 0;
		gint _tmp57_ = 0;
		cairo_surface_t* _tmp58_ = NULL;
		cairo_surface_t* _tmp59_ = NULL;
		_tmp10_ = self->stats;
		_tmp10__length1 = self->stats_length1;
		if (_tmp10_ == NULL) {
			_tmp9_ = TRUE;
		} else {
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			_tmp11_ = new_pixmap_width;
			_tmp12_ = self->pixmap_width;
			_tmp9_ = _tmp11_ != _tmp12_;
		}
		if (_tmp9_) {
			gdouble* new_stats = NULL;
			gint _tmp13_ = 0;
			gdouble* _tmp14_ = NULL;
			gint new_stats_length1 = 0;
			gint _new_stats_size_ = 0;
			gdouble* _tmp15_ = NULL;
			gint _tmp15__length1 = 0;
			gdouble* _tmp16_ = NULL;
			gint _tmp16__length1 = 0;
			gdouble* _tmp52_ = NULL;
			gint _tmp52__length1 = 0;
			gdouble* _tmp53_ = NULL;
			gint _tmp53__length1 = 0;
			_tmp13_ = new_pixmap_width;
			_tmp14_ = g_new0 (gdouble, _tmp13_);
			new_stats = _tmp14_;
			new_stats_length1 = _tmp13_;
			_new_stats_size_ = new_stats_length1;
			_tmp15_ = new_stats;
			_tmp15__length1 = new_stats_length1;
			if (_tmp15_ == NULL) {
				result = TRUE;
				new_stats = (g_free (new_stats), NULL);
				return result;
			}
			_tmp16_ = self->stats;
			_tmp16__length1 = self->stats_length1;
			if (_tmp16_ != NULL) {
				gint _tmp17_ = 0;
				gint _tmp18_ = 0;
				_tmp17_ = new_pixmap_width;
				_tmp18_ = self->pixmap_width;
				if (_tmp17_ > _tmp18_) {
					gint nvalues = 0;
					gint _tmp19_ = 0;
					gint _tmp20_ = 0;
					gdouble* _tmp21_ = NULL;
					gint _tmp21__length1 = 0;
					gdouble* _tmp22_ = NULL;
					gint _tmp22__length1 = 0;
					gint _tmp23_ = 0;
					gdouble* _tmp24_ = NULL;
					gint _tmp24__length1 = 0;
					gint _tmp25_ = 0;
					gdouble* _tmp26_ = NULL;
					gint _tmp26__length1 = 0;
					gdouble* _tmp27_ = NULL;
					gint _tmp27__length1 = 0;
					gint _tmp28_ = 0;
					gdouble* _tmp29_ = NULL;
					gint _tmp29__length1 = 0;
					gint _tmp30_ = 0;
					_tmp19_ = self->pixmap_width;
					_tmp20_ = self->ring_cursor;
					nvalues = _tmp19_ - _tmp20_;
					_tmp21_ = new_stats;
					_tmp21__length1 = new_stats_length1;
					_tmp22_ = self->stats;
					_tmp22__length1 = self->stats_length1;
					_tmp23_ = self->ring_cursor;
					memcpy ((void*) _tmp21_, (void*) _tmp22_, (gsize) (_tmp23_ * sizeof (gdouble)));
					_tmp24_ = new_stats;
					_tmp24__length1 = new_stats_length1;
					_tmp25_ = nvalues;
					_tmp26_ = new_stats;
					_tmp26__length1 = new_stats_length1;
					_tmp27_ = self->stats;
					_tmp27__length1 = self->stats_length1;
					_tmp28_ = self->ring_cursor;
					_tmp29_ = self->stats;
					_tmp29__length1 = self->stats_length1;
					_tmp30_ = nvalues;
					memcpy ((void*) (_tmp24_ + _tmp25_), (void*) (_tmp27_ + _tmp28_), (gsize) (_tmp30_ * sizeof (gdouble)));
				} else {
					gint _tmp31_ = 0;
					gint _tmp32_ = 0;
					_tmp31_ = self->ring_cursor;
					_tmp32_ = new_pixmap_width;
					if (_tmp31_ <= _tmp32_) {
						gint nvalues = 0;
						gint _tmp33_ = 0;
						gint _tmp34_ = 0;
						gdouble* _tmp35_ = NULL;
						gint _tmp35__length1 = 0;
						gdouble* _tmp36_ = NULL;
						gint _tmp36__length1 = 0;
						gint _tmp37_ = 0;
						gdouble* _tmp38_ = NULL;
						gint _tmp38__length1 = 0;
						gint _tmp39_ = 0;
						gdouble* _tmp40_ = NULL;
						gint _tmp40__length1 = 0;
						gdouble* _tmp41_ = NULL;
						gint _tmp41__length1 = 0;
						gint _tmp42_ = 0;
						gint _tmp43_ = 0;
						gdouble* _tmp44_ = NULL;
						gint _tmp44__length1 = 0;
						gint _tmp45_ = 0;
						_tmp33_ = new_pixmap_width;
						_tmp34_ = self->ring_cursor;
						nvalues = _tmp33_ - _tmp34_;
						_tmp35_ = new_stats;
						_tmp35__length1 = new_stats_length1;
						_tmp36_ = self->stats;
						_tmp36__length1 = self->stats_length1;
						_tmp37_ = self->ring_cursor;
						memcpy ((void*) _tmp35_, (void*) _tmp36_, (gsize) (_tmp37_ * sizeof (gdouble)));
						_tmp38_ = new_stats;
						_tmp38__length1 = new_stats_length1;
						_tmp39_ = self->ring_cursor;
						_tmp40_ = new_stats;
						_tmp40__length1 = new_stats_length1;
						_tmp41_ = self->stats;
						_tmp41__length1 = self->stats_length1;
						_tmp42_ = self->pixmap_width;
						_tmp43_ = nvalues;
						_tmp44_ = self->stats;
						_tmp44__length1 = self->stats_length1;
						_tmp45_ = nvalues;
						memcpy ((void*) (_tmp38_ + _tmp39_), (void*) (_tmp41_ + (_tmp42_ - _tmp43_)), (gsize) (_tmp45_ * sizeof (gdouble)));
					} else {
						gdouble* _tmp46_ = NULL;
						gint _tmp46__length1 = 0;
						gdouble* _tmp47_ = NULL;
						gint _tmp47__length1 = 0;
						gint _tmp48_ = 0;
						gint _tmp49_ = 0;
						gdouble* _tmp50_ = NULL;
						gint _tmp50__length1 = 0;
						gint _tmp51_ = 0;
						_tmp46_ = new_stats;
						_tmp46__length1 = new_stats_length1;
						_tmp47_ = self->stats;
						_tmp47__length1 = self->stats_length1;
						_tmp48_ = self->ring_cursor;
						_tmp49_ = new_pixmap_width;
						_tmp50_ = self->stats;
						_tmp50__length1 = self->stats_length1;
						_tmp51_ = new_pixmap_width;
						memcpy ((void*) _tmp46_, (void*) (_tmp47_ + (_tmp48_ - _tmp49_)), (gsize) (_tmp51_ * sizeof (gdouble)));
					}
				}
			}
			_tmp52_ = new_stats;
			_tmp52__length1 = new_stats_length1;
			_tmp53_ = (_tmp52_ != NULL) ? _vala_array_dup1 (_tmp52_, _tmp52__length1) : ((gpointer) _tmp52_);
			_tmp53__length1 = _tmp52__length1;
			self->stats = (g_free (self->stats), NULL);
			self->stats = _tmp53_;
			self->stats_length1 = _tmp53__length1;
			self->_stats_size_ = self->stats_length1;
			new_stats = (g_free (new_stats), NULL);
		}
		_tmp54_ = new_pixmap_width;
		self->pixmap_width = _tmp54_;
		_tmp55_ = new_pixmap_height;
		self->pixmap_height = _tmp55_;
		_tmp56_ = self->pixmap_width;
		_tmp57_ = self->pixmap_height;
		_tmp58_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, (gint) _tmp56_, (gint) _tmp57_);
		_cairo_surface_destroy0 (self->pixmap);
		self->pixmap = _tmp58_;
		_tmp59_ = self->pixmap;
		cairo_surface_status (_tmp59_);
		monitor_redraw_pixmap (self);
	}
	result = TRUE;
	return result;
}


static gboolean ___lambda4__gtk_widget_configure_event (GtkWidget* _sender, GdkEventConfigure* event, gpointer self) {
	gboolean result;
	result = __lambda4_ ((Monitor*) self, event);
	return result;
}


static gboolean __lambda5_ (Monitor* self, cairo_t* cr) {
	gboolean result = FALSE;
	cairo_surface_t* _tmp0_ = NULL;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = self->pixmap;
	if (_tmp0_ != NULL) {
		cairo_t* _tmp1_ = NULL;
		cairo_surface_t* _tmp2_ = NULL;
		cairo_t* _tmp3_ = NULL;
		cairo_t* _tmp4_ = NULL;
		_tmp1_ = cr;
		_tmp2_ = self->pixmap;
		cairo_set_source_surface (_tmp1_, _tmp2_, (gdouble) MONITOR_BORDER_SIZE, (gdouble) MONITOR_BORDER_SIZE);
		_tmp3_ = cr;
		cairo_paint (_tmp3_);
		_tmp4_ = cr;
		cairo_status (_tmp4_);
	}
	result = FALSE;
	return result;
}


static gboolean ___lambda5__gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = __lambda5_ ((Monitor*) self, cr);
	return result;
}


static gboolean __lambda6_ (Block1Data* _data1_, GdkEventButton* e) {
	Monitor* self;
	gboolean result = FALSE;
	GdkEventButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	self = _data1_->self;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = e;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ == ((guint) 1)) {
		Monitors* _tmp2_ = NULL;
		GSettings* _tmp3_ = NULL;
		GSettings* _tmp4_ = NULL;
		GVariant* _tmp5_ = NULL;
		GVariant* _tmp6_ = NULL;
		Monitors* _tmp7_ = NULL;
		ValaPanelToplevel* _tmp8_ = NULL;
		ValaPanelToplevel* _tmp9_ = NULL;
		GtkApplication* _tmp10_ = NULL;
		GtkApplication* _tmp11_ = NULL;
		_tmp2_ = _data1_->plugin;
		_tmp3_ = vala_panel_applet_get_settings ((PanelApplet*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_settings_get_value (_tmp4_, MONITORS_ACTION);
		_tmp6_ = _tmp5_;
		_tmp7_ = _data1_->plugin;
		_tmp8_ = vala_panel_applet_get_toplevel ((PanelApplet*) _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = gtk_window_get_application ((GtkWindow*) _tmp9_);
		_tmp11_ = _tmp10_;
		activate_menu_launch_command (NULL, _tmp6_, _tmp11_);
		_g_variant_unref0 (_tmp6_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean ___lambda6__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda6_ (self, event);
	return result;
}


Monitor* monitor_new (Monitors* plugin, const gchar* color) {
	Monitor* self;
	Block1Data* _data1_;
	Monitors* _tmp0_ = NULL;
	Monitors* _tmp1_ = NULL;
	GtkDrawingArea* _tmp2_ = NULL;
	GtkDrawingArea* _tmp3_ = NULL;
	Monitors* _tmp4_ = NULL;
	ValaPanelToplevel* _tmp5_ = NULL;
	ValaPanelToplevel* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	GtkDrawingArea* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	GtkDrawingArea* _tmp11_ = NULL;
	GtkDrawingArea* _tmp12_ = NULL;
	GtkDrawingArea* _tmp13_ = NULL;
	g_return_val_if_fail (plugin != NULL, NULL);
	g_return_val_if_fail (color != NULL, NULL);
	self = g_slice_new0 (Monitor);
	monitor_instance_init (self);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = monitor_ref (self);
	_tmp0_ = plugin;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data1_->plugin);
	_data1_->plugin = _tmp1_;
	self->ref_count = (volatile int) 1;
	_tmp2_ = (GtkDrawingArea*) gtk_drawing_area_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->da);
	self->da = _tmp2_;
	_tmp3_ = self->da;
	_tmp4_ = _data1_->plugin;
	_tmp5_ = vala_panel_applet_get_toplevel ((PanelApplet*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = vala_panel_toplevel_get_height (_tmp6_);
	_tmp8_ = _tmp7_;
	gtk_widget_set_size_request ((GtkWidget*) _tmp3_, MONITOR_DEFAULT_WIDTH, _tmp8_);
	_tmp9_ = self->da;
	gtk_widget_add_events ((GtkWidget*) _tmp9_, (gint) GDK_BUTTON_PRESS_MASK);
	_tmp10_ = color;
	gdk_rgba_parse (&self->foreground_color, _tmp10_);
	_tmp11_ = self->da;
	g_signal_connect ((GtkWidget*) _tmp11_, "configure-event", (GCallback) ___lambda4__gtk_widget_configure_event, self);
	_tmp12_ = self->da;
	g_signal_connect ((GtkWidget*) _tmp12_, "draw", (GCallback) ___lambda5__gtk_widget_draw, self);
	_tmp13_ = self->da;
	g_signal_connect_data ((GtkWidget*) _tmp13_, "button-release-event", (GCallback) ___lambda6__gtk_widget_button_release_event, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return self;
}


void monitor_redraw_pixmap (Monitor* self) {
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp0_ = NULL;
	cairo_t* _tmp1_ = NULL;
	cairo_t* _tmp2_ = NULL;
	cairo_t* _tmp3_ = NULL;
	cairo_t* _tmp4_ = NULL;
	cairo_t* _tmp5_ = NULL;
	GdkRGBA _tmp6_ = {0};
	cairo_t* _tmp24_ = NULL;
	GtkDrawingArea* _tmp25_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->pixmap;
	_tmp1_ = cairo_create (_tmp0_);
	cr = _tmp1_;
	_tmp2_ = cr;
	cairo_set_line_width (_tmp2_, 1.0);
	_tmp3_ = cr;
	cairo_set_source_rgba (_tmp3_, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
	_tmp4_ = cr;
	cairo_paint (_tmp4_);
	_tmp5_ = cr;
	_tmp6_ = self->foreground_color;
	gdk_cairo_set_source_rgba (_tmp5_, &_tmp6_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				guint drawing_cursor = 0U;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				cairo_t* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				gint _tmp16_ = 0;
				cairo_t* _tmp17_ = NULL;
				gint _tmp18_ = 0;
				gdouble* _tmp19_ = NULL;
				gint _tmp19__length1 = 0;
				guint _tmp20_ = 0U;
				gdouble _tmp21_ = 0.0;
				gint _tmp22_ = 0;
				cairo_t* _tmp23_ = NULL;
				if (!_tmp7_) {
					gint _tmp8_ = 0;
					_tmp8_ = i;
					i = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				_tmp9_ = i;
				_tmp10_ = self->pixmap_width;
				if (!(_tmp9_ < _tmp10_)) {
					break;
				}
				_tmp11_ = self->ring_cursor;
				_tmp12_ = i;
				_tmp13_ = self->pixmap_width;
				drawing_cursor = (guint) ((_tmp11_ + _tmp12_) % _tmp13_);
				_tmp14_ = cr;
				_tmp15_ = i;
				_tmp16_ = self->pixmap_height;
				cairo_move_to (_tmp14_, _tmp15_ + 0.5, (gdouble) _tmp16_);
				_tmp17_ = cr;
				_tmp18_ = i;
				_tmp19_ = self->stats;
				_tmp19__length1 = self->stats_length1;
				_tmp20_ = drawing_cursor;
				_tmp21_ = _tmp19_[_tmp20_];
				_tmp22_ = self->pixmap_height;
				cairo_line_to (_tmp17_, _tmp18_ + 0.5, (1.0 - _tmp21_) * _tmp22_);
				_tmp23_ = cr;
				cairo_stroke (_tmp23_);
			}
		}
	}
	_tmp24_ = cr;
	cairo_status (_tmp24_);
	_tmp25_ = self->da;
	gtk_widget_queue_draw ((GtkWidget*) _tmp25_);
	_cairo_destroy0 (cr);
}


Monitor* monitor_ref (Monitor* self) {
	Monitor* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_atomic_int_add ((volatile gint *) (&self->ref_count), 1);
	result = self;
	return result;
}


void monitor_unref (Monitor* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_atomic_int_dec_and_test ((volatile gint *) (&self->ref_count));
	if (_tmp0_) {
		monitor_free (self);
	}
}


static void monitor_instance_init (Monitor * self) {
}


void monitor_free (Monitor* self) {
	GtkDrawingArea* _tmp0_ = NULL;
	_tmp0_ = self->da;
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
	_g_object_unref0 (self->da);
	self->da = NULL;
	_g_object_unref0 (self->da);
	_cairo_surface_destroy0 (self->pixmap);
	self->stats = (g_free (self->stats), NULL);
	g_slice_free (Monitor, self);
}


static gboolean _cpu_monitor_update_cpu_monitor_update_monitor_func (Monitor* m) {
	gboolean result;
	result = cpu_monitor_update_cpu (m);
	return result;
}


static void _cpu_monitor_tooltip_update_cpu_monitor_update_tooltip_func (Monitor* m) {
	cpu_monitor_tooltip_update_cpu (m);
}


CpuMonitor* cpu_monitor_new (Monitors* plugin, const gchar* color) {
	CpuMonitor* self;
	Monitors* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (plugin != NULL, NULL);
	g_return_val_if_fail (color != NULL, NULL);
	_tmp0_ = plugin;
	_tmp1_ = color;
	self = (CpuMonitor*) monitor_new (_tmp0_, _tmp1_);
	((Monitor*) self)->position = 0;
	((Monitor*) self)->update_monitor = _cpu_monitor_update_cpu_monitor_update_monitor_func;
	((Monitor*) self)->update_tooltip = _cpu_monitor_tooltip_update_cpu_monitor_update_tooltip_func;
	return self;
}


gboolean cpu_monitor_update_cpu (Monitor* c) {
	gboolean result = FALSE;
	CpuMonitorcpu_stat previous_cpu_stat = {0};
	CpuMonitorcpu_stat _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Monitor* _tmp2_ = NULL;
	gdouble* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	g_return_val_if_fail (c != NULL, FALSE);
	_tmp0_.u = (gint64) 0;
	_tmp0_.n = (gint64) 0;
	_tmp0_.s = (gint64) 0;
	_tmp0_.i = (gint64) 0;
	previous_cpu_stat = _tmp0_;
	_tmp2_ = c;
	_tmp3_ = _tmp2_->stats;
	_tmp3__length1 = _tmp2_->stats_length1;
	if (_tmp3_ != NULL) {
		Monitor* _tmp4_ = NULL;
		cairo_surface_t* _tmp5_ = NULL;
		_tmp4_ = c;
		_tmp5_ = _tmp4_->pixmap;
		_tmp1_ = _tmp5_ != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		CpuMonitorcpu_stat cpu = {0};
		FILE* stat = NULL;
		FILE* _tmp6_ = NULL;
		FILE* _tmp7_ = NULL;
		gint fscanf_result = 0;
		FILE* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		memset (&cpu, 0, sizeof (CpuMonitorcpu_stat));
		_tmp6_ = fopen ("/proc/stat", "r");
		stat = _tmp6_;
		_tmp7_ = stat;
		if (_tmp7_ == NULL) {
			result = TRUE;
			_fclose0 (stat);
			return result;
		}
		_tmp8_ = stat;
		_tmp9_ = fscanf (_tmp8_, "cpu %li %li %li %li", &cpu.u, &cpu.n, &cpu.s, &cpu.i);
		fscanf_result = _tmp9_;
		_tmp10_ = fscanf_result;
		if (_tmp10_ == 4) {
			CpuMonitorcpu_stat cpu_delta = {0};
			CpuMonitorcpu_stat _tmp11_ = {0};
			gint64 _tmp12_ = 0LL;
			CpuMonitorcpu_stat _tmp13_ = {0};
			gint64 _tmp14_ = 0LL;
			CpuMonitorcpu_stat _tmp15_ = {0};
			gint64 _tmp16_ = 0LL;
			CpuMonitorcpu_stat _tmp17_ = {0};
			gint64 _tmp18_ = 0LL;
			CpuMonitorcpu_stat _tmp19_ = {0};
			gint64 _tmp20_ = 0LL;
			CpuMonitorcpu_stat _tmp21_ = {0};
			gint64 _tmp22_ = 0LL;
			CpuMonitorcpu_stat _tmp23_ = {0};
			gint64 _tmp24_ = 0LL;
			CpuMonitorcpu_stat _tmp25_ = {0};
			gint64 _tmp26_ = 0LL;
			CpuMonitorcpu_stat _tmp27_ = {0};
			gdouble cpu_uns = 0.0;
			CpuMonitorcpu_stat _tmp28_ = {0};
			gint64 _tmp29_ = 0LL;
			CpuMonitorcpu_stat _tmp30_ = {0};
			gint64 _tmp31_ = 0LL;
			CpuMonitorcpu_stat _tmp32_ = {0};
			gint64 _tmp33_ = 0LL;
			Monitor* _tmp34_ = NULL;
			gdouble* _tmp35_ = NULL;
			gint _tmp35__length1 = 0;
			Monitor* _tmp36_ = NULL;
			gint _tmp37_ = 0;
			gdouble _tmp38_ = 0.0;
			gdouble _tmp39_ = 0.0;
			CpuMonitorcpu_stat _tmp40_ = {0};
			gint64 _tmp41_ = 0LL;
			gdouble _tmp42_ = 0.0;
			Monitor* _tmp43_ = NULL;
			Monitor* _tmp44_ = NULL;
			gint _tmp45_ = 0;
			Monitor* _tmp46_ = NULL;
			gint _tmp47_ = 0;
			Monitor* _tmp48_ = NULL;
			gint _tmp49_ = 0;
			Monitor* _tmp51_ = NULL;
			memset (&cpu_delta, 0, sizeof (CpuMonitorcpu_stat));
			_tmp11_ = cpu;
			_tmp12_ = _tmp11_.u;
			_tmp13_ = previous_cpu_stat;
			_tmp14_ = _tmp13_.u;
			cpu_delta.u = _tmp12_ - _tmp14_;
			_tmp15_ = cpu;
			_tmp16_ = _tmp15_.n;
			_tmp17_ = previous_cpu_stat;
			_tmp18_ = _tmp17_.n;
			cpu_delta.n = _tmp16_ - _tmp18_;
			_tmp19_ = cpu;
			_tmp20_ = _tmp19_.s;
			_tmp21_ = previous_cpu_stat;
			_tmp22_ = _tmp21_.s;
			cpu_delta.s = _tmp20_ - _tmp22_;
			_tmp23_ = cpu;
			_tmp24_ = _tmp23_.i;
			_tmp25_ = previous_cpu_stat;
			_tmp26_ = _tmp25_.i;
			cpu_delta.i = _tmp24_ - _tmp26_;
			_tmp27_ = cpu;
			previous_cpu_stat = _tmp27_;
			_tmp28_ = cpu_delta;
			_tmp29_ = _tmp28_.u;
			_tmp30_ = cpu_delta;
			_tmp31_ = _tmp30_.n;
			_tmp32_ = cpu_delta;
			_tmp33_ = _tmp32_.s;
			cpu_uns = (gdouble) ((_tmp29_ + _tmp31_) + _tmp33_);
			_tmp34_ = c;
			_tmp35_ = _tmp34_->stats;
			_tmp35__length1 = _tmp34_->stats_length1;
			_tmp36_ = c;
			_tmp37_ = _tmp36_->ring_cursor;
			_tmp38_ = cpu_uns;
			_tmp39_ = cpu_uns;
			_tmp40_ = cpu_delta;
			_tmp41_ = _tmp40_.i;
			_tmp35_[_tmp37_] = _tmp38_ / (_tmp39_ + _tmp41_);
			_tmp42_ = _tmp35_[_tmp37_];
			_tmp43_ = c;
			_tmp44_ = c;
			_tmp45_ = _tmp44_->ring_cursor;
			_tmp44_->ring_cursor = _tmp45_ + 1;
			_tmp46_ = c;
			_tmp47_ = _tmp46_->ring_cursor;
			_tmp48_ = c;
			_tmp49_ = _tmp48_->pixmap_width;
			if (_tmp47_ >= _tmp49_) {
				Monitor* _tmp50_ = NULL;
				_tmp50_ = c;
				_tmp50_->ring_cursor = 0;
			}
			_tmp51_ = c;
			monitor_redraw_pixmap (_tmp51_);
		}
		_fclose0 (stat);
	}
	result = TRUE;
	return result;
}


void cpu_monitor_tooltip_update_cpu (Monitor* m) {
	gboolean _tmp0_ = FALSE;
	Monitor* _tmp1_ = NULL;
	_tmp1_ = m;
	if (_tmp1_ != NULL) {
		Monitor* _tmp2_ = NULL;
		gdouble* _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
		_tmp2_ = m;
		_tmp3_ = _tmp2_->stats;
		_tmp3__length1 = _tmp2_->stats_length1;
		_tmp0_ = _tmp3_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint _tmp4_ = 0;
		Monitor* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gint ring_pos = 0;
		Monitor* _tmp11_ = NULL;
		GtkDrawingArea* _tmp12_ = NULL;
		_tmp5_ = m;
		_tmp6_ = _tmp5_->ring_cursor;
		if (_tmp6_ == 0) {
			Monitor* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			_tmp7_ = m;
			_tmp8_ = _tmp7_->pixmap_width;
			_tmp4_ = _tmp8_ - 1;
		} else {
			Monitor* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			_tmp9_ = m;
			_tmp10_ = _tmp9_->ring_cursor;
			_tmp4_ = _tmp10_ - 1;
		}
		ring_pos = _tmp4_;
		_tmp11_ = m;
		_tmp12_ = _tmp11_->da;
		if (_tmp12_ != NULL) {
			Monitor* _tmp13_ = NULL;
			GtkDrawingArea* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			Monitor* _tmp16_ = NULL;
			gdouble* _tmp17_ = NULL;
			gint _tmp17__length1 = 0;
			gint _tmp18_ = 0;
			gdouble _tmp19_ = 0.0;
			gchar* _tmp20_ = NULL;
			gchar* _tmp21_ = NULL;
			_tmp13_ = m;
			_tmp14_ = _tmp13_->da;
			_tmp15_ = _ ("CPU usage: %.2f%%");
			_tmp16_ = m;
			_tmp17_ = _tmp16_->stats;
			_tmp17__length1 = _tmp16_->stats_length1;
			_tmp18_ = ring_pos;
			_tmp19_ = _tmp17_[_tmp18_];
			_tmp20_ = g_strdup_printf (_tmp15_, _tmp19_ * 100);
			_tmp21_ = _tmp20_;
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _tmp21_);
			_g_free0 (_tmp21_);
		}
	}
}


static CpuMonitorcpu_stat* cpu_monitor_cpu_stat_dup (const CpuMonitorcpu_stat* self) {
	CpuMonitorcpu_stat* dup;
	dup = g_new0 (CpuMonitorcpu_stat, 1);
	memcpy (dup, self, sizeof (CpuMonitorcpu_stat));
	return dup;
}


static void cpu_monitor_cpu_stat_free (CpuMonitorcpu_stat* self) {
	g_free (self);
}


static GType cpu_monitor_cpu_stat_get_type (void) {
	static volatile gsize cpu_monitor_cpu_stat_type_id__volatile = 0;
	if (g_once_init_enter (&cpu_monitor_cpu_stat_type_id__volatile)) {
		GType cpu_monitor_cpu_stat_type_id;
		cpu_monitor_cpu_stat_type_id = g_boxed_type_register_static ("CpuMonitorcpu_stat", (GBoxedCopyFunc) cpu_monitor_cpu_stat_dup, (GBoxedFreeFunc) cpu_monitor_cpu_stat_free);
		g_once_init_leave (&cpu_monitor_cpu_stat_type_id__volatile, cpu_monitor_cpu_stat_type_id);
	}
	return cpu_monitor_cpu_stat_type_id__volatile;
}


static gboolean _mem_monitor_update_mem_monitor_update_monitor_func (Monitor* m) {
	gboolean result;
	result = mem_monitor_update_mem (m);
	return result;
}


static void _mem_monitor_tooltip_update_mem_monitor_update_tooltip_func (Monitor* m) {
	mem_monitor_tooltip_update_mem (m);
}


MemMonitor* mem_monitor_new (Monitors* plugin, const gchar* color) {
	MemMonitor* self;
	Monitors* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (plugin != NULL, NULL);
	g_return_val_if_fail (color != NULL, NULL);
	_tmp0_ = plugin;
	_tmp1_ = color;
	self = (MemMonitor*) monitor_new (_tmp0_, _tmp1_);
	((Monitor*) self)->position = 1;
	((Monitor*) self)->update_monitor = _mem_monitor_update_mem_monitor_update_monitor_func;
	((Monitor*) self)->update_tooltip = _mem_monitor_tooltip_update_mem_monitor_update_tooltip_func;
	return self;
}


gboolean mem_monitor_update_mem (Monitor* m) {
	gboolean result = FALSE;
	gchar buf[80] = {0};
	glong mem_total = 0L;
	glong mem_free = 0L;
	glong mem_buffers = 0L;
	glong mem_cached = 0L;
	guint readmask = 0U;
	gboolean _tmp0_ = FALSE;
	Monitor* _tmp1_ = NULL;
	gdouble* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	FILE* meminfo = NULL;
	FILE* _tmp5_ = NULL;
	FILE* _tmp6_ = NULL;
	guint _tmp26_ = 0U;
	Monitor* _tmp28_ = NULL;
	glong _tmp29_ = 0L;
	Monitor* _tmp30_ = NULL;
	gdouble* _tmp31_ = NULL;
	gint _tmp31__length1 = 0;
	Monitor* _tmp32_ = NULL;
	gint _tmp33_ = 0;
	glong _tmp34_ = 0L;
	glong _tmp35_ = 0L;
	glong _tmp36_ = 0L;
	glong _tmp37_ = 0L;
	glong _tmp38_ = 0L;
	gdouble _tmp39_ = 0.0;
	Monitor* _tmp40_ = NULL;
	Monitor* _tmp41_ = NULL;
	gint _tmp42_ = 0;
	Monitor* _tmp43_ = NULL;
	gint _tmp44_ = 0;
	Monitor* _tmp45_ = NULL;
	gint _tmp46_ = 0;
	Monitor* _tmp48_ = NULL;
	g_return_val_if_fail (m != NULL, FALSE);
	mem_total = (glong) 0;
	mem_free = (glong) 0;
	mem_buffers = (glong) 0;
	mem_cached = (glong) 0;
	readmask = (guint) (((0x8 | 0x4) | 0x2) | 0x1);
	_tmp1_ = m;
	_tmp2_ = _tmp1_->stats;
	_tmp2__length1 = _tmp1_->stats_length1;
	if (_tmp2_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		Monitor* _tmp3_ = NULL;
		cairo_surface_t* _tmp4_ = NULL;
		_tmp3_ = m;
		_tmp4_ = _tmp3_->pixmap;
		_tmp0_ = _tmp4_ == NULL;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	_tmp5_ = fopen ("/proc/meminfo", "r");
	meminfo = _tmp5_;
	_tmp6_ = meminfo;
	if (_tmp6_ == NULL) {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		const gchar* _tmp9_ = NULL;
		_tmp7_ = errno;
		_tmp8_ = errno;
		_tmp9_ = strerror (_tmp8_);
		g_warning ("monitors.vala:277: monitors: Could not open /proc/meminfo: %d, %s", _tmp7_, _tmp9_);
		result = FALSE;
		_fclose0 (meminfo);
		return result;
	}
	while (TRUE) {
		gboolean _tmp10_ = FALSE;
		guint _tmp11_ = 0U;
		const gchar* buf_str = NULL;
		const gchar* _tmp14_ = NULL;
		gint _tmp15_ = 0;
		const gchar* _tmp17_ = NULL;
		gint _tmp18_ = 0;
		const gchar* _tmp20_ = NULL;
		gint _tmp21_ = 0;
		const gchar* _tmp23_ = NULL;
		gint _tmp24_ = 0;
		_tmp11_ = readmask;
		if (_tmp11_ != ((guint) 0)) {
			FILE* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
			_tmp12_ = meminfo;
			_tmp13_ = fgets (buf, 80, _tmp12_);
			_tmp10_ = _tmp13_ != NULL;
		} else {
			_tmp10_ = FALSE;
		}
		if (!_tmp10_) {
			break;
		}
		buf_str = (const gchar*) buf;
		_tmp14_ = buf_str;
		_tmp15_ = sscanf (_tmp14_, "MemTotal: %ld kB\n", &mem_total);
		if (_tmp15_ == 1) {
			guint _tmp16_ = 0U;
			_tmp16_ = readmask;
			readmask = _tmp16_ ^ 0x1;
			continue;
		}
		_tmp17_ = buf_str;
		_tmp18_ = sscanf (_tmp17_, "MemFree: %ld kB\n", &mem_free);
		if (_tmp18_ == 1) {
			guint _tmp19_ = 0U;
			_tmp19_ = readmask;
			readmask = _tmp19_ ^ 0x2;
			continue;
		}
		_tmp20_ = buf_str;
		_tmp21_ = sscanf (_tmp20_, "Buffers: %ld kB\n", &mem_buffers);
		if (_tmp21_ == 1) {
			guint _tmp22_ = 0U;
			_tmp22_ = readmask;
			readmask = _tmp22_ ^ 0x4;
			continue;
		}
		_tmp23_ = buf_str;
		_tmp24_ = sscanf (_tmp23_, "Cached: %ld kB\n", &mem_cached);
		if (_tmp24_ == 1) {
			guint _tmp25_ = 0U;
			_tmp25_ = readmask;
			readmask = _tmp25_ ^ 0x8;
			continue;
		}
	}
	_tmp26_ = readmask;
	if (_tmp26_ != ((guint) 0)) {
		guint _tmp27_ = 0U;
		_tmp27_ = readmask;
		g_warning ("monitors.vala:308: monitors: Could not read all values from /proc/memi" \
"nfo:\n" \
"                      readmask %x", _tmp27_);
		result = FALSE;
		_fclose0 (meminfo);
		return result;
	}
	_tmp28_ = m;
	_tmp29_ = mem_total;
	_tmp28_->total = (gdouble) _tmp29_;
	_tmp30_ = m;
	_tmp31_ = _tmp30_->stats;
	_tmp31__length1 = _tmp30_->stats_length1;
	_tmp32_ = m;
	_tmp33_ = _tmp32_->ring_cursor;
	_tmp34_ = mem_total;
	_tmp35_ = mem_buffers;
	_tmp36_ = mem_free;
	_tmp37_ = mem_cached;
	_tmp38_ = mem_total;
	_tmp31_[_tmp33_] = (((_tmp34_ - _tmp35_) - _tmp36_) - _tmp37_) / ((gdouble) _tmp38_);
	_tmp39_ = _tmp31_[_tmp33_];
	_tmp40_ = m;
	_tmp41_ = m;
	_tmp42_ = _tmp41_->ring_cursor;
	_tmp41_->ring_cursor = _tmp42_ + 1;
	_tmp43_ = m;
	_tmp44_ = _tmp43_->ring_cursor;
	_tmp45_ = m;
	_tmp46_ = _tmp45_->pixmap_width;
	if (_tmp44_ >= _tmp46_) {
		Monitor* _tmp47_ = NULL;
		_tmp47_ = m;
		_tmp47_->ring_cursor = 0;
	}
	_tmp48_ = m;
	monitor_redraw_pixmap (_tmp48_);
	result = TRUE;
	_fclose0 (meminfo);
	return result;
}


void mem_monitor_tooltip_update_mem (Monitor* m) {
	gboolean _tmp0_ = FALSE;
	Monitor* _tmp1_ = NULL;
	_tmp1_ = m;
	if (_tmp1_ != NULL) {
		Monitor* _tmp2_ = NULL;
		gdouble* _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
		_tmp2_ = m;
		_tmp3_ = _tmp2_->stats;
		_tmp3__length1 = _tmp2_->stats_length1;
		_tmp0_ = _tmp3_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint _tmp4_ = 0;
		Monitor* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gint ring_pos = 0;
		Monitor* _tmp11_ = NULL;
		GtkDrawingArea* _tmp12_ = NULL;
		_tmp5_ = m;
		_tmp6_ = _tmp5_->ring_cursor;
		if (_tmp6_ == 0) {
			Monitor* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			_tmp7_ = m;
			_tmp8_ = _tmp7_->pixmap_width;
			_tmp4_ = _tmp8_ - 1;
		} else {
			Monitor* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			_tmp9_ = m;
			_tmp10_ = _tmp9_->ring_cursor;
			_tmp4_ = _tmp10_ - 1;
		}
		ring_pos = _tmp4_;
		_tmp11_ = m;
		_tmp12_ = _tmp11_->da;
		if (_tmp12_ != NULL) {
			Monitor* _tmp13_ = NULL;
			GtkDrawingArea* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			Monitor* _tmp16_ = NULL;
			gdouble* _tmp17_ = NULL;
			gint _tmp17__length1 = 0;
			gint _tmp18_ = 0;
			gdouble _tmp19_ = 0.0;
			Monitor* _tmp20_ = NULL;
			gdouble _tmp21_ = 0.0;
			Monitor* _tmp22_ = NULL;
			gdouble* _tmp23_ = NULL;
			gint _tmp23__length1 = 0;
			gint _tmp24_ = 0;
			gdouble _tmp25_ = 0.0;
			gchar* _tmp26_ = NULL;
			gchar* _tmp27_ = NULL;
			_tmp13_ = m;
			_tmp14_ = _tmp13_->da;
			_tmp15_ = _ ("RAM usage: %.1fMB (%.2f%%)");
			_tmp16_ = m;
			_tmp17_ = _tmp16_->stats;
			_tmp17__length1 = _tmp16_->stats_length1;
			_tmp18_ = ring_pos;
			_tmp19_ = _tmp17_[_tmp18_];
			_tmp20_ = m;
			_tmp21_ = _tmp20_->total;
			_tmp22_ = m;
			_tmp23_ = _tmp22_->stats;
			_tmp23__length1 = _tmp22_->stats_length1;
			_tmp24_ = ring_pos;
			_tmp25_ = _tmp23_[_tmp24_];
			_tmp26_ = g_strdup_printf (_tmp15_, (_tmp19_ * _tmp21_) / 1024, _tmp25_ * 100);
			_tmp27_ = _tmp26_;
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _tmp27_);
			_g_free0 (_tmp27_);
		}
	}
}


Monitors* monitors_construct (GType object_type, ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	Monitors * self = NULL;
	ValaPanelToplevel* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	g_return_val_if_fail (toplevel != NULL, NULL);
	_tmp0_ = toplevel;
	_tmp1_ = settings;
	_tmp2_ = number;
	self = (Monitors*) vala_panel_applet_construct (object_type, _tmp0_, _tmp1_, _tmp2_);
	return self;
}


Monitors* monitors_new (ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	return monitors_construct (TYPE_MONITORS, toplevel, settings, number);
}


static GtkDialog* monitors_real_get_config_dialog (ValaPanelAppletConfigurable* base) {
	Monitors * self;
	GtkDialog* result = NULL;
	const gchar* _tmp0_ = NULL;
	ValaPanelToplevel* _tmp1_ = NULL;
	ValaPanelToplevel* _tmp2_ = NULL;
	GSettings* _tmp3_ = NULL;
	GSettings* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	GtkDialog* _tmp10_ = NULL;
	self = (Monitors*) base;
	_tmp0_ = _ ("Resource monitors");
	_tmp1_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = _ ("Display CPU usage");
	_tmp6_ = _ ("CPU color");
	_tmp7_ = _ ("Display RAM usage");
	_tmp8_ = _ ("RAM color");
	_tmp9_ = _ ("Action when clicked");
	_tmp10_ = generic_config_dlg (_tmp0_, (GtkWindow*) _tmp2_, _tmp4_, _tmp5_, MONITORS_DISPLAY_CPU, CONF_BOOL, _tmp6_, MONITORS_CPU_CL, CONF_STR, _tmp7_, MONITORS_DISPLAY_RAM, CONF_BOOL, _tmp8_, MONITORS_RAM_CL, CONF_STR, _tmp9_, MONITORS_ACTION, CONF_STR, NULL);
	result = _tmp10_;
	return result;
}


static gboolean _monitors_monitors_update_gsource_func (gpointer self) {
	gboolean result;
	result = monitors_monitors_update ((Monitors*) self);
	return result;
}


static void __lambda7_ (Monitors* self, const gchar* key) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	if (g_strcmp0 (_tmp0_, MONITORS_DISPLAY_CPU) == 0) {
		gboolean* _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		GSettings* _tmp2_ = NULL;
		GSettings* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		_tmp1_ = self->priv->displayed_mons;
		_tmp1__length1 = self->priv->displayed_mons_length1;
		_tmp2_ = vala_panel_applet_get_settings ((PanelApplet*) self);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_settings_get_boolean (_tmp3_, MONITORS_DISPLAY_CPU);
		_tmp1_[(gint) MONITOR_TYPE_CPU] = _tmp4_;
		_tmp5_ = _tmp1_[(gint) MONITOR_TYPE_CPU];
		monitors_rebuild_mons (self);
	} else {
		const gchar* _tmp6_ = NULL;
		_tmp6_ = key;
		if (g_strcmp0 (_tmp6_, MONITORS_DISPLAY_RAM) == 0) {
			gboolean* _tmp7_ = NULL;
			gint _tmp7__length1 = 0;
			GSettings* _tmp8_ = NULL;
			GSettings* _tmp9_ = NULL;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			_tmp7_ = self->priv->displayed_mons;
			_tmp7__length1 = self->priv->displayed_mons_length1;
			_tmp8_ = vala_panel_applet_get_settings ((PanelApplet*) self);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_settings_get_boolean (_tmp9_, MONITORS_DISPLAY_RAM);
			_tmp7_[(gint) MONITOR_TYPE_RAM] = _tmp10_;
			_tmp11_ = _tmp7_[(gint) MONITOR_TYPE_RAM];
			monitors_rebuild_mons (self);
		} else {
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_ = NULL;
			_tmp13_ = key;
			if (g_strcmp0 (_tmp13_, MONITORS_CPU_CL) == 0) {
				Monitor** _tmp14_ = NULL;
				gint _tmp14__length1 = 0;
				Monitor* _tmp15_ = NULL;
				_tmp14_ = self->priv->monitors;
				_tmp14__length1 = self->priv->monitors_length1;
				_tmp15_ = _tmp14_[(gint) MONITOR_TYPE_CPU];
				_tmp12_ = _tmp15_ != NULL;
			} else {
				_tmp12_ = FALSE;
			}
			if (_tmp12_) {
				Monitor** _tmp16_ = NULL;
				gint _tmp16__length1 = 0;
				Monitor* _tmp17_ = NULL;
				GSettings* _tmp18_ = NULL;
				GSettings* _tmp19_ = NULL;
				gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				_tmp16_ = self->priv->monitors;
				_tmp16__length1 = self->priv->monitors_length1;
				_tmp17_ = _tmp16_[(gint) MONITOR_TYPE_CPU];
				_tmp18_ = vala_panel_applet_get_settings ((PanelApplet*) self);
				_tmp19_ = _tmp18_;
				_tmp20_ = g_settings_get_string (_tmp19_, MONITORS_CPU_CL);
				_tmp21_ = _tmp20_;
				gdk_rgba_parse (&_tmp17_->foreground_color, _tmp21_);
				_g_free0 (_tmp21_);
			} else {
				gboolean _tmp22_ = FALSE;
				const gchar* _tmp23_ = NULL;
				_tmp23_ = key;
				if (g_strcmp0 (_tmp23_, MONITORS_RAM_CL) == 0) {
					Monitor** _tmp24_ = NULL;
					gint _tmp24__length1 = 0;
					Monitor* _tmp25_ = NULL;
					_tmp24_ = self->priv->monitors;
					_tmp24__length1 = self->priv->monitors_length1;
					_tmp25_ = _tmp24_[(gint) MONITOR_TYPE_RAM];
					_tmp22_ = _tmp25_ != NULL;
				} else {
					_tmp22_ = FALSE;
				}
				if (_tmp22_) {
					Monitor** _tmp26_ = NULL;
					gint _tmp26__length1 = 0;
					Monitor* _tmp27_ = NULL;
					GSettings* _tmp28_ = NULL;
					GSettings* _tmp29_ = NULL;
					gchar* _tmp30_ = NULL;
					gchar* _tmp31_ = NULL;
					_tmp26_ = self->priv->monitors;
					_tmp26__length1 = self->priv->monitors_length1;
					_tmp27_ = _tmp26_[(gint) MONITOR_TYPE_RAM];
					_tmp28_ = vala_panel_applet_get_settings ((PanelApplet*) self);
					_tmp29_ = _tmp28_;
					_tmp30_ = g_settings_get_string (_tmp29_, MONITORS_RAM_CL);
					_tmp31_ = _tmp30_;
					gdk_rgba_parse (&_tmp27_->foreground_color, _tmp31_);
					_g_free0 (_tmp31_);
				}
			}
		}
	}
}


static void ___lambda7__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	__lambda7_ ((Monitors*) self, key);
}


static void __lambda8_ (Monitors* self) {
	guint _tmp0_ = 0U;
	_tmp0_ = self->priv->timer;
	g_source_remove (_tmp0_);
}


static void ___lambda8__gtk_widget_destroy (GtkWidget* _sender, gpointer self) {
	__lambda8_ ((Monitors*) self);
}


static void monitors_real_create (PanelApplet* base) {
	Monitors * self;
	Monitor** _tmp0_ = NULL;
	GtkBox* _tmp1_ = NULL;
	GtkBox* _tmp2_ = NULL;
	gboolean* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	GSettings* _tmp4_ = NULL;
	GSettings* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	GSettings* _tmp9_ = NULL;
	GSettings* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean* _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	gboolean _tmp14_ = FALSE;
	gboolean* _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	gboolean _tmp19_ = FALSE;
	guint _tmp23_ = 0U;
	GSettings* _tmp24_ = NULL;
	GSettings* _tmp25_ = NULL;
	GtkBox* _tmp26_ = NULL;
	self = (Monitors*) base;
	_tmp0_ = g_new0 (Monitor*, 2 + 1);
	self->priv->monitors = (_vala_array_free (self->priv->monitors, self->priv->monitors_length1, (GDestroyNotify) monitor_unref), NULL);
	self->priv->monitors = _tmp0_;
	self->priv->monitors_length1 = 2;
	self->priv->_monitors_size_ = self->priv->monitors_length1;
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 2);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->box);
	self->priv->box = _tmp1_;
	_tmp2_ = self->priv->box;
	gtk_box_set_homogeneous (_tmp2_, TRUE);
	_tmp3_ = self->priv->displayed_mons;
	_tmp3__length1 = self->priv->displayed_mons_length1;
	_tmp4_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_settings_get_boolean (_tmp5_, MONITORS_DISPLAY_CPU);
	_tmp3_[(gint) MONITOR_TYPE_CPU] = _tmp6_;
	_tmp7_ = _tmp3_[(gint) MONITOR_TYPE_CPU];
	_tmp8_ = self->priv->displayed_mons;
	_tmp8__length1 = self->priv->displayed_mons_length1;
	_tmp9_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_settings_get_boolean (_tmp10_, MONITORS_DISPLAY_RAM);
	_tmp8_[(gint) MONITOR_TYPE_RAM] = _tmp11_;
	_tmp12_ = _tmp8_[(gint) MONITOR_TYPE_RAM];
	_tmp13_ = self->priv->displayed_mons;
	_tmp13__length1 = self->priv->displayed_mons_length1;
	_tmp14_ = _tmp13_[(gint) MONITOR_TYPE_CPU];
	if (_tmp14_) {
		Monitor** _tmp15_ = NULL;
		gint _tmp15__length1 = 0;
		Monitor* _tmp16_ = NULL;
		Monitor* _tmp17_ = NULL;
		_tmp15_ = self->priv->monitors;
		_tmp15__length1 = self->priv->monitors_length1;
		_tmp16_ = monitors_create_monitor (self, MONITOR_TYPE_CPU);
		_monitor_unref0 (_tmp15_[(gint) MONITOR_TYPE_CPU]);
		_tmp15_[(gint) MONITOR_TYPE_CPU] = _tmp16_;
		_tmp17_ = _tmp15_[(gint) MONITOR_TYPE_CPU];
	}
	_tmp18_ = self->priv->displayed_mons;
	_tmp18__length1 = self->priv->displayed_mons_length1;
	_tmp19_ = _tmp18_[(gint) MONITOR_TYPE_RAM];
	if (_tmp19_) {
		Monitor** _tmp20_ = NULL;
		gint _tmp20__length1 = 0;
		Monitor* _tmp21_ = NULL;
		Monitor* _tmp22_ = NULL;
		_tmp20_ = self->priv->monitors;
		_tmp20__length1 = self->priv->monitors_length1;
		_tmp21_ = monitors_create_monitor (self, MONITOR_TYPE_RAM);
		_monitor_unref0 (_tmp20_[(gint) MONITOR_TYPE_RAM]);
		_tmp20_[(gint) MONITOR_TYPE_RAM] = _tmp21_;
		_tmp22_ = _tmp20_[(gint) MONITOR_TYPE_RAM];
	}
	_tmp23_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, MONITORS_UPDATE_PERIOD, _monitors_monitors_update_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->timer = _tmp23_;
	_tmp24_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp25_ = _tmp24_;
	g_signal_connect_object (_tmp25_, "changed", (GCallback) ___lambda7__g_settings_changed, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) ___lambda8__gtk_widget_destroy, self, 0);
	_tmp26_ = self->priv->box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp26_);
	gtk_widget_show_all ((GtkWidget*) self);
}


static void monitors_rebuild_mons (Monitors* self) {
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_ = 0;
				gboolean _tmp3_ = FALSE;
				gboolean* _tmp4_ = NULL;
				gint _tmp4__length1 = 0;
				gint _tmp5_ = 0;
				gboolean _tmp6_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_ = 0;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				if (!(_tmp2_ < ((gint) MONITOR_TYPE_N_MONS))) {
					break;
				}
				_tmp4_ = self->priv->displayed_mons;
				_tmp4__length1 = self->priv->displayed_mons_length1;
				_tmp5_ = i;
				_tmp6_ = _tmp4_[_tmp5_];
				if (_tmp6_) {
					Monitor** _tmp7_ = NULL;
					gint _tmp7__length1 = 0;
					gint _tmp8_ = 0;
					Monitor* _tmp9_ = NULL;
					_tmp7_ = self->priv->monitors;
					_tmp7__length1 = self->priv->monitors_length1;
					_tmp8_ = i;
					_tmp9_ = _tmp7_[_tmp8_];
					_tmp3_ = _tmp9_ == NULL;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					Monitor** _tmp10_ = NULL;
					gint _tmp10__length1 = 0;
					gint _tmp11_ = 0;
					gint _tmp12_ = 0;
					Monitor* _tmp13_ = NULL;
					Monitor* _tmp14_ = NULL;
					GtkBox* _tmp15_ = NULL;
					Monitor** _tmp16_ = NULL;
					gint _tmp16__length1 = 0;
					gint _tmp17_ = 0;
					Monitor* _tmp18_ = NULL;
					GtkDrawingArea* _tmp19_ = NULL;
					Monitor** _tmp20_ = NULL;
					gint _tmp20__length1 = 0;
					gint _tmp21_ = 0;
					Monitor* _tmp22_ = NULL;
					gint _tmp23_ = 0;
					_tmp10_ = self->priv->monitors;
					_tmp10__length1 = self->priv->monitors_length1;
					_tmp11_ = i;
					_tmp12_ = i;
					_tmp13_ = monitors_create_monitor (self, (MonitorType) _tmp12_);
					_monitor_unref0 (_tmp10_[_tmp11_]);
					_tmp10_[_tmp11_] = _tmp13_;
					_tmp14_ = _tmp10_[_tmp11_];
					_tmp15_ = self->priv->box;
					_tmp16_ = self->priv->monitors;
					_tmp16__length1 = self->priv->monitors_length1;
					_tmp17_ = i;
					_tmp18_ = _tmp16_[_tmp17_];
					_tmp19_ = _tmp18_->da;
					_tmp20_ = self->priv->monitors;
					_tmp20__length1 = self->priv->monitors_length1;
					_tmp21_ = i;
					_tmp22_ = _tmp20_[_tmp21_];
					_tmp23_ = _tmp22_->position;
					gtk_box_reorder_child (_tmp15_, (GtkWidget*) _tmp19_, _tmp23_);
				} else {
					gboolean _tmp24_ = FALSE;
					gboolean* _tmp25_ = NULL;
					gint _tmp25__length1 = 0;
					gint _tmp26_ = 0;
					gboolean _tmp27_ = FALSE;
					_tmp25_ = self->priv->displayed_mons;
					_tmp25__length1 = self->priv->displayed_mons_length1;
					_tmp26_ = i;
					_tmp27_ = _tmp25_[_tmp26_];
					if (!_tmp27_) {
						Monitor** _tmp28_ = NULL;
						gint _tmp28__length1 = 0;
						gint _tmp29_ = 0;
						Monitor* _tmp30_ = NULL;
						_tmp28_ = self->priv->monitors;
						_tmp28__length1 = self->priv->monitors_length1;
						_tmp29_ = i;
						_tmp30_ = _tmp28_[_tmp29_];
						_tmp24_ = _tmp30_ != NULL;
					} else {
						_tmp24_ = FALSE;
					}
					if (_tmp24_) {
						GtkBox* _tmp31_ = NULL;
						Monitor** _tmp32_ = NULL;
						gint _tmp32__length1 = 0;
						gint _tmp33_ = 0;
						Monitor* _tmp34_ = NULL;
						GtkDrawingArea* _tmp35_ = NULL;
						Monitor** _tmp36_ = NULL;
						gint _tmp36__length1 = 0;
						gint _tmp37_ = 0;
						Monitor* _tmp38_ = NULL;
						_tmp31_ = self->priv->box;
						_tmp32_ = self->priv->monitors;
						_tmp32__length1 = self->priv->monitors_length1;
						_tmp33_ = i;
						_tmp34_ = _tmp32_[_tmp33_];
						_tmp35_ = _tmp34_->da;
						gtk_container_remove ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp35_);
						_tmp36_ = self->priv->monitors;
						_tmp36__length1 = self->priv->monitors_length1;
						_tmp37_ = i;
						_monitor_unref0 (_tmp36_[_tmp37_]);
						_tmp36_[_tmp37_] = NULL;
						_tmp38_ = _tmp36_[_tmp37_];
					}
				}
			}
		}
	}
}


static gboolean monitors_monitors_update (Monitors* self) {
	gboolean result = FALSE;
	GSource* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_main_current_source ();
	_tmp1_ = g_source_is_destroyed (_tmp0_);
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_ = 0;
				Monitor** _tmp5_ = NULL;
				gint _tmp5__length1 = 0;
				gint _tmp6_ = 0;
				Monitor* _tmp7_ = NULL;
				if (!_tmp2_) {
					gint _tmp3_ = 0;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = i;
				if (!(((guint) _tmp4_) < MONITORS_N_MONITORS)) {
					break;
				}
				_tmp5_ = self->priv->monitors;
				_tmp5__length1 = self->priv->monitors_length1;
				_tmp6_ = i;
				_tmp7_ = _tmp5_[_tmp6_];
				if (_tmp7_ != NULL) {
					Monitor** _tmp8_ = NULL;
					gint _tmp8__length1 = 0;
					gint _tmp9_ = 0;
					Monitor* _tmp10_ = NULL;
					_tmp8_ = self->priv->monitors;
					_tmp8__length1 = self->priv->monitors_length1;
					_tmp9_ = i;
					_tmp10_ = _tmp8_[_tmp9_];
					monitor_update (_tmp10_);
				}
			}
		}
	}
	result = TRUE;
	return result;
}


static Monitor* monitors_create_monitor (Monitors* self, MonitorType type) {
	Monitor* result = NULL;
	Monitor* new_mon = NULL;
	MonitorType _tmp0_ = 0;
	MonitorType _tmp6_ = 0;
	Monitor* _tmp12_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	new_mon = NULL;
	_tmp0_ = type;
	if (_tmp0_ == MONITOR_TYPE_CPU) {
		GSettings* _tmp1_ = NULL;
		GSettings* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		CpuMonitor* _tmp5_ = NULL;
		_tmp1_ = vala_panel_applet_get_settings ((PanelApplet*) self);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_settings_get_string (_tmp2_, MONITORS_CPU_CL);
		_tmp4_ = _tmp3_;
		_tmp5_ = cpu_monitor_new (self, _tmp4_);
		_monitor_unref0 (new_mon);
		new_mon = (Monitor*) _tmp5_;
		_g_free0 (_tmp4_);
	}
	_tmp6_ = type;
	if (_tmp6_ == MONITOR_TYPE_RAM) {
		GSettings* _tmp7_ = NULL;
		GSettings* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		MemMonitor* _tmp11_ = NULL;
		_tmp7_ = vala_panel_applet_get_settings ((PanelApplet*) self);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_settings_get_string (_tmp8_, MONITORS_RAM_CL);
		_tmp10_ = _tmp9_;
		_tmp11_ = mem_monitor_new (self, _tmp10_);
		_monitor_unref0 (new_mon);
		new_mon = (Monitor*) _tmp11_;
		_g_free0 (_tmp10_);
	}
	_tmp12_ = new_mon;
	if (_tmp12_ != NULL) {
		GtkBox* _tmp13_ = NULL;
		Monitor* _tmp14_ = NULL;
		GtkDrawingArea* _tmp15_ = NULL;
		Monitor* _tmp16_ = NULL;
		GtkDrawingArea* _tmp17_ = NULL;
		_tmp13_ = self->priv->box;
		_tmp14_ = new_mon;
		_tmp15_ = _tmp14_->da;
		gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp15_, FALSE, FALSE, (guint) 0);
		_tmp16_ = new_mon;
		_tmp17_ = _tmp16_->da;
		gtk_widget_show ((GtkWidget*) _tmp17_);
	}
	result = new_mon;
	return result;
}


static void monitors_class_init (MonitorsClass * klass) {
	monitors_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MonitorsPrivate));
	((PanelAppletClass *) klass)->create = monitors_real_create;
	G_OBJECT_CLASS (klass)->finalize = monitors_finalize;
}


static void monitors_vala_panel_applet_configurable_interface_init (ValaPanelAppletConfigurableIface * iface) {
	monitors_vala_panel_applet_configurable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_config_dialog = (GtkDialog* (*)(ValaPanelAppletConfigurable*)) monitors_real_get_config_dialog;
}


static void monitors_instance_init (Monitors * self) {
	gboolean* _tmp0_ = NULL;
	self->priv = MONITORS_GET_PRIVATE (self);
	_tmp0_ = g_new0 (gboolean, 2);
	_tmp0_[0] = TRUE;
	_tmp0_[1] = TRUE;
	self->priv->displayed_mons = _tmp0_;
	self->priv->displayed_mons_length1 = 2;
	self->priv->_displayed_mons_size_ = self->priv->displayed_mons_length1;
}


static void monitors_finalize (GObject* obj) {
	Monitors * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MONITORS, Monitors);
	self->priv->monitors = (_vala_array_free (self->priv->monitors, self->priv->monitors_length1, (GDestroyNotify) monitor_unref), NULL);
	self->priv->displayed_mons = (g_free (self->priv->displayed_mons), NULL);
	_g_object_unref0 (self->priv->box);
	G_OBJECT_CLASS (monitors_parent_class)->finalize (obj);
}


GType monitors_get_type (void) {
	return monitors_type_id;
}


GType monitors_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MonitorsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) monitors_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Monitors), 0, (GInstanceInitFunc) monitors_instance_init, NULL };
	static const GInterfaceInfo vala_panel_applet_configurable_info = { (GInterfaceInitFunc) monitors_vala_panel_applet_configurable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	monitors_type_id = g_type_module_register_type (module, VALA_PANEL_TYPE_APPLET, "Monitors", &g_define_type_info, 0);
	g_type_module_add_interface (module, monitors_type_id, VALA_PANEL_TYPE_APPLET_CONFIGURABLE, &vala_panel_applet_configurable_info);
	return monitors_type_id;
}


void peas_register_types (GTypeModule* module) {
	PeasObjectModule* objmodule = NULL;
	GTypeModule* _tmp0_ = NULL;
	PeasObjectModule* _tmp1_ = NULL;
	g_return_if_fail (module != NULL);
	monitors_applet_register_type (module);
	monitors_register_type (module);
	_tmp0_ = module;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, peas_object_module_get_type ()) ? ((PeasObjectModule*) _tmp0_) : NULL);
	objmodule = _tmp1_;
	peas_object_module_register_extension_type (objmodule, VALA_PANEL_TYPE_APPLET_PLUGIN, TYPE_MONITORS_APPLET);
	_g_object_unref0 (objmodule);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



