/* wincmd.c generated by valac 0.32.1, the Vala compiler
 * generated from wincmd.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <libpeas/peas.h>
#include <vala-panel-compat.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <lib/generic-config-dialog.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <lib/misc.h>
#include <libwnck/libwnck.h>
#include <gdk/gdkx.h>
#include <gdk/gdk.h>


#define TYPE_WINCMD_APPLET (wincmd_applet_get_type ())
#define WINCMD_APPLET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WINCMD_APPLET, WincmdApplet))
#define WINCMD_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WINCMD_APPLET, WincmdAppletClass))
#define IS_WINCMD_APPLET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WINCMD_APPLET))
#define IS_WINCMD_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WINCMD_APPLET))
#define WINCMD_APPLET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WINCMD_APPLET, WincmdAppletClass))

typedef struct _WincmdApplet WincmdApplet;
typedef struct _WincmdAppletClass WincmdAppletClass;
typedef struct _WincmdAppletPrivate WincmdAppletPrivate;

#define TYPE_WINCMD (wincmd_get_type ())
#define WINCMD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WINCMD, Wincmd))
#define WINCMD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WINCMD, WincmdClass))
#define IS_WINCMD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WINCMD))
#define IS_WINCMD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WINCMD))
#define WINCMD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WINCMD, WincmdClass))

typedef struct _Wincmd Wincmd;
typedef struct _WincmdClass WincmdClass;
typedef struct _WincmdPrivate WincmdPrivate;

#define WINCMD_TYPE_COMMAND (wincmd_command_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _WincmdApplet {
	PeasExtensionBase parent_instance;
	WincmdAppletPrivate * priv;
};

struct _WincmdAppletClass {
	PeasExtensionBaseClass parent_class;
};

struct _Wincmd {
	PanelApplet parent_instance;
	WincmdPrivate * priv;
};

struct _WincmdClass {
	PanelAppletClass parent_class;
};

typedef enum  {
	WINCMD_COMMAND_NONE = 0,
	WINCMD_COMMAND_ICONIFY = 1,
	WINCMD_COMMAND_SHADE = 2
} WincmdCommand;

struct _WincmdPrivate {
	GtkButton* button;
	GtkImage* image;
	gboolean toggle_state;
	WincmdCommand _left_button_command;
	WincmdCommand _middle_button_command;
	gboolean _toggle_iconify_and_shade;
	gchar* _icon;
};


static gpointer wincmd_applet_parent_class = NULL;
static ValaPanelAppletPluginIface* wincmd_applet_vala_panel_applet_plugin_parent_iface = NULL;
static GType wincmd_applet_type_id = 0;
static gpointer wincmd_parent_class = NULL;
static ValaPanelAppletConfigurableIface* wincmd_vala_panel_applet_configurable_parent_iface = NULL;
static GType wincmd_type_id = 0;

GType wincmd_applet_get_type (void) G_GNUC_CONST;
GType wincmd_applet_register_type (GTypeModule * module);
enum  {
	WINCMD_APPLET_DUMMY_PROPERTY
};
static PanelApplet* wincmd_applet_real_get_applet_widget (ValaPanelAppletPlugin* base, ValaPanelToplevel* toplevel, GSettings* settings, guint number);
Wincmd* wincmd_new (ValaPanelToplevel* toplevel, GSettings* settings, guint number);
Wincmd* wincmd_construct (GType object_type, ValaPanelToplevel* toplevel, GSettings* settings, guint number);
GType wincmd_get_type (void) G_GNUC_CONST;
GType wincmd_register_type (GTypeModule * module);
WincmdApplet* wincmd_applet_new (void);
WincmdApplet* wincmd_applet_construct (GType object_type);
GType wincmd_command_get_type (void) G_GNUC_CONST;
#define WINCMD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_WINCMD, WincmdPrivate))
enum  {
	WINCMD_DUMMY_PROPERTY,
	WINCMD_LEFT_BUTTON_COMMAND,
	WINCMD_MIDDLE_BUTTON_COMMAND,
	WINCMD_TOGGLE_ICONIFY_AND_SHADE,
	WINCMD_ICON
};
#define WINCMD_KEY_LEFT "left-button-command"
#define WINCMD_KEY_MIDDLE "middle-button-command"
#define WINCMD_KEY_TOGGLE "toggle-iconify-and-shade"
#define WINCMD_KEY_ICON "icon"
static GtkDialog* wincmd_real_get_config_dialog (ValaPanelAppletConfigurable* base);
static void wincmd_real_create (PanelApplet* base);
const gchar* wincmd_get_icon (Wincmd* self);
static void __lambda4_ (Wincmd* self);
static void wincmd_execute_command (Wincmd* self, WincmdCommand command);
WincmdCommand wincmd_get_left_button_command (Wincmd* self);
static void ___lambda4__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void __lambda5_ (Wincmd* self, GParamSpec* pspec);
static void wincmd_update_icon (Wincmd* self);
static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
gboolean wincmd_get_toggle_iconify_and_shade (Wincmd* self);
static void wincmd_adjust_toggle_state (Wincmd* self);
static gboolean wincmd_real_button_release_event (GtkWidget* base, GdkEventButton* e);
WincmdCommand wincmd_get_middle_button_command (Wincmd* self);
void wincmd_set_left_button_command (Wincmd* self, WincmdCommand value);
void wincmd_set_middle_button_command (Wincmd* self, WincmdCommand value);
void wincmd_set_toggle_iconify_and_shade (Wincmd* self, gboolean value);
void wincmd_set_icon (Wincmd* self, const gchar* value);
static void wincmd_finalize (GObject* obj);
static void _vala_wincmd_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_wincmd_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
void peas_register_types (GTypeModule* module);


static PanelApplet* wincmd_applet_real_get_applet_widget (ValaPanelAppletPlugin* base, ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	WincmdApplet * self;
	PanelApplet* result = NULL;
	ValaPanelToplevel* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	Wincmd* _tmp3_ = NULL;
	self = (WincmdApplet*) base;
	g_return_val_if_fail (toplevel != NULL, NULL);
	_tmp0_ = toplevel;
	_tmp1_ = settings;
	_tmp2_ = number;
	_tmp3_ = wincmd_new (_tmp0_, _tmp1_, _tmp2_);
	g_object_ref_sink (_tmp3_);
	result = (PanelApplet*) _tmp3_;
	return result;
}


WincmdApplet* wincmd_applet_construct (GType object_type) {
	WincmdApplet * self = NULL;
	self = (WincmdApplet*) g_object_new (object_type, NULL);
	return self;
}


WincmdApplet* wincmd_applet_new (void) {
	return wincmd_applet_construct (TYPE_WINCMD_APPLET);
}


static void wincmd_applet_class_init (WincmdAppletClass * klass) {
	wincmd_applet_parent_class = g_type_class_peek_parent (klass);
}


static void wincmd_applet_vala_panel_applet_plugin_interface_init (ValaPanelAppletPluginIface * iface) {
	wincmd_applet_vala_panel_applet_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_applet_widget = (PanelApplet* (*)(ValaPanelAppletPlugin*, ValaPanelToplevel*, GSettings*, guint)) wincmd_applet_real_get_applet_widget;
}


static void wincmd_applet_instance_init (WincmdApplet * self) {
}


GType wincmd_applet_get_type (void) {
	return wincmd_applet_type_id;
}


GType wincmd_applet_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (WincmdAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wincmd_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WincmdApplet), 0, (GInstanceInitFunc) wincmd_applet_instance_init, NULL };
	static const GInterfaceInfo vala_panel_applet_plugin_info = { (GInterfaceInitFunc) wincmd_applet_vala_panel_applet_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	wincmd_applet_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "WincmdApplet", &g_define_type_info, 0);
	g_type_module_add_interface (module, wincmd_applet_type_id, VALA_PANEL_TYPE_APPLET_PLUGIN, &vala_panel_applet_plugin_info);
	return wincmd_applet_type_id;
}


GType wincmd_command_get_type (void) {
	static volatile gsize wincmd_command_type_id__volatile = 0;
	if (g_once_init_enter (&wincmd_command_type_id__volatile)) {
		static const GEnumValue values[] = {{WINCMD_COMMAND_NONE, "WINCMD_COMMAND_NONE", "none"}, {WINCMD_COMMAND_ICONIFY, "WINCMD_COMMAND_ICONIFY", "iconify"}, {WINCMD_COMMAND_SHADE, "WINCMD_COMMAND_SHADE", "shade"}, {0, NULL, NULL}};
		GType wincmd_command_type_id;
		wincmd_command_type_id = g_enum_register_static ("WincmdCommand", values);
		g_once_init_leave (&wincmd_command_type_id__volatile, wincmd_command_type_id);
	}
	return wincmd_command_type_id__volatile;
}


Wincmd* wincmd_construct (GType object_type, ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	Wincmd * self = NULL;
	ValaPanelToplevel* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	g_return_val_if_fail (toplevel != NULL, NULL);
	_tmp0_ = toplevel;
	_tmp1_ = settings;
	_tmp2_ = number;
	self = (Wincmd*) vala_panel_applet_construct (object_type, _tmp0_, _tmp1_, _tmp2_);
	return self;
}


Wincmd* wincmd_new (ValaPanelToplevel* toplevel, GSettings* settings, guint number) {
	return wincmd_construct (TYPE_WINCMD, toplevel, settings, number);
}


static GtkDialog* wincmd_real_get_config_dialog (ValaPanelAppletConfigurable* base) {
	Wincmd * self;
	GtkDialog* result = NULL;
	const gchar* _tmp0_ = NULL;
	ValaPanelToplevel* _tmp1_ = NULL;
	ValaPanelToplevel* _tmp2_ = NULL;
	GSettings* _tmp3_ = NULL;
	GSettings* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	GtkDialog* _tmp6_ = NULL;
	self = (Wincmd*) base;
	_tmp0_ = _ ("Minimize All Windows");
	_tmp1_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = _ ("Alternately iconify/shade and raise");
	_tmp6_ = generic_config_dlg (_tmp0_, (GtkWindow*) _tmp2_, _tmp4_, _tmp5_, WINCMD_KEY_TOGGLE, CONF_BOOL, NULL);
	result = _tmp6_;
	return result;
}


static void __lambda4_ (Wincmd* self) {
	WincmdCommand _tmp0_ = 0;
	_tmp0_ = self->priv->_left_button_command;
	wincmd_execute_command (self, _tmp0_);
}


static void ___lambda4__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	__lambda4_ ((Wincmd*) self);
}


static void __lambda5_ (Wincmd* self, GParamSpec* pspec) {
	g_return_if_fail (pspec != NULL);
	wincmd_update_icon (self);
}


static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda5_ ((Wincmd*) self, pspec);
}


static void wincmd_real_create (PanelApplet* base) {
	Wincmd * self;
	GtkButton* _tmp0_ = NULL;
	GtkImage* _tmp1_ = NULL;
	GSettings* _tmp2_ = NULL;
	GSettings* _tmp3_ = NULL;
	GSettings* _tmp4_ = NULL;
	GSettings* _tmp5_ = NULL;
	GSettings* _tmp6_ = NULL;
	GSettings* _tmp7_ = NULL;
	GSettings* _tmp8_ = NULL;
	GSettings* _tmp9_ = NULL;
	GIcon* gicon = NULL;
	GThemedIcon* _tmp10_ = NULL;
	GtkImage* _tmp17_ = NULL;
	GIcon* _tmp18_ = NULL;
	ValaPanelToplevel* _tmp19_ = NULL;
	ValaPanelToplevel* _tmp20_ = NULL;
	GtkButton* _tmp21_ = NULL;
	GtkImage* _tmp22_ = NULL;
	GtkButton* _tmp23_ = NULL;
	GtkImage* _tmp24_ = NULL;
	GtkButton* _tmp25_ = NULL;
	GtkButton* _tmp26_ = NULL;
	GError * _inner_error_ = NULL;
	self = (Wincmd*) base;
	_tmp0_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->button);
	self->priv->button = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->image);
	self->priv->image = _tmp1_;
	_tmp2_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp3_ = _tmp2_;
	g_settings_bind (_tmp3_, WINCMD_KEY_LEFT, (GObject*) self, WINCMD_KEY_LEFT, G_SETTINGS_BIND_GET);
	_tmp4_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp5_ = _tmp4_;
	g_settings_bind (_tmp5_, WINCMD_KEY_MIDDLE, (GObject*) self, WINCMD_KEY_MIDDLE, G_SETTINGS_BIND_GET);
	_tmp6_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp7_ = _tmp6_;
	g_settings_bind (_tmp7_, WINCMD_KEY_TOGGLE, (GObject*) self, WINCMD_KEY_TOGGLE, G_SETTINGS_BIND_GET);
	_tmp8_ = vala_panel_applet_get_settings ((PanelApplet*) self);
	_tmp9_ = _tmp8_;
	g_settings_bind (_tmp9_, WINCMD_KEY_ICON, (GObject*) self, WINCMD_KEY_ICON, G_SETTINGS_BIND_GET);
	_tmp10_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
	gicon = (GIcon*) _tmp10_;
	{
		GIcon* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		GIcon* _tmp13_ = NULL;
		GIcon* _tmp14_ = NULL;
		_tmp12_ = self->priv->_icon;
		_tmp13_ = g_icon_new_for_string (_tmp12_, &_inner_error_);
		_tmp11_ = _tmp13_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp14_ = _tmp11_;
		_tmp11_ = NULL;
		_g_object_unref0 (gicon);
		gicon = _tmp14_;
		_g_object_unref0 (_tmp11_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp15_ = NULL;
		GThemedIcon* _tmp16_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp15_ = stderr;
		fprintf (_tmp15_, "Default icon will be used\n");
		_tmp16_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
		_g_object_unref0 (gicon);
		gicon = (GIcon*) _tmp16_;
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (gicon);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp17_ = self->priv->image;
	_tmp18_ = gicon;
	_tmp19_ = vala_panel_applet_get_toplevel ((PanelApplet*) self);
	_tmp20_ = _tmp19_;
	vala_panel_setup_icon (_tmp17_, _tmp18_, _tmp20_, -1);
	_tmp21_ = self->priv->button;
	_tmp22_ = self->priv->image;
	vala_panel_setup_button (_tmp21_, _tmp22_, NULL);
	_tmp23_ = self->priv->button;
	_tmp24_ = self->priv->image;
	gtk_button_set_image (_tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = self->priv->button;
	g_signal_connect_object (_tmp25_, "clicked", (GCallback) ___lambda4__gtk_button_clicked, self, 0);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda5__g_object_notify, self, 0);
	_tmp26_ = self->priv->button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp26_);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (gicon);
}


static void wincmd_update_icon (Wincmd* self) {
	GIcon* gicon = NULL;
	GThemedIcon* _tmp0_ = NULL;
	GtkImage* _tmp7_ = NULL;
	GIcon* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
	gicon = (GIcon*) _tmp0_;
	{
		GIcon* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		GIcon* _tmp3_ = NULL;
		GIcon* _tmp4_ = NULL;
		_tmp2_ = self->priv->_icon;
		_tmp3_ = g_icon_new_for_string (_tmp2_, &_inner_error_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (gicon);
		gicon = _tmp4_;
		_g_object_unref0 (_tmp1_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_ = NULL;
		GThemedIcon* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = stderr;
		fprintf (_tmp5_, "Default icon will be used\n");
		_tmp6_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
		_g_object_unref0 (gicon);
		gicon = (GIcon*) _tmp6_;
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (gicon);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp7_ = self->priv->image;
	_tmp8_ = gicon;
	gtk_image_set_from_gicon (_tmp7_, _tmp8_, GTK_ICON_SIZE_INVALID);
	_g_object_unref0 (gicon);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void wincmd_execute_command (Wincmd* self, WincmdCommand command) {
	WnckScreen* scr = NULL;
	WnckScreen* _tmp0_ = NULL;
	WnckScreen* _tmp1_ = NULL;
	WincmdCommand _tmp2_ = 0;
	WnckWorkspace* desk = NULL;
	WnckScreen* _tmp15_ = NULL;
	WnckWorkspace* _tmp16_ = NULL;
	WnckWorkspace* _tmp17_ = NULL;
	WnckScreen* _tmp18_ = NULL;
	GList* _tmp19_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = wnck_screen_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	scr = _tmp1_;
	_tmp2_ = command;
	if (_tmp2_ == WINCMD_COMMAND_ICONIFY) {
		GdkX11Screen* screen = NULL;
		GdkScreen* _tmp3_ = NULL;
		GdkX11Screen* _tmp4_ = NULL;
		GdkAtom atom = 0U;
		GdkAtom _tmp5_ = 0U;
		GdkX11Screen* _tmp6_ = NULL;
		GdkAtom _tmp7_ = 0U;
		gboolean _tmp8_ = FALSE;
		_tmp3_ = gtk_widget_get_screen ((GtkWidget*) self);
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gdk_x11_screen_get_type ()) ? ((GdkX11Screen*) _tmp3_) : NULL);
		screen = _tmp4_;
		_tmp5_ = gdk_atom_intern ("_NET_SHOWING_DESKTOP", FALSE);
		atom = _tmp5_;
		_tmp6_ = screen;
		_tmp7_ = atom;
		_tmp8_ = gdk_x11_screen_supports_net_wm_hint (_tmp6_, _tmp7_);
		if (_tmp8_) {
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			gboolean showing_desktop = FALSE;
			WnckScreen* _tmp13_ = NULL;
			gboolean _tmp14_ = FALSE;
			_tmp11_ = self->priv->_toggle_iconify_and_shade;
			if (!_tmp11_) {
				_tmp10_ = TRUE;
			} else {
				gboolean _tmp12_ = FALSE;
				_tmp12_ = self->priv->toggle_state;
				_tmp10_ = !_tmp12_;
			}
			if (_tmp10_) {
				_tmp9_ = TRUE;
			} else {
				_tmp9_ = FALSE;
			}
			showing_desktop = _tmp9_;
			_tmp13_ = scr;
			_tmp14_ = showing_desktop;
			wnck_screen_toggle_showing_desktop (_tmp13_, _tmp14_);
			wincmd_adjust_toggle_state (self);
			_g_object_unref0 (screen);
			_g_object_unref0 (scr);
			return;
		}
		_g_object_unref0 (screen);
	}
	_tmp15_ = scr;
	_tmp16_ = wnck_screen_get_active_workspace (_tmp15_);
	_tmp17_ = _g_object_ref0 (_tmp16_);
	desk = _tmp17_;
	_tmp18_ = scr;
	_tmp19_ = wnck_screen_get_windows (_tmp18_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp19_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* _tmp20_ = NULL;
			WnckWindow* window = NULL;
			_tmp20_ = _g_object_ref0 ((WnckWindow*) window_it->data);
			window = _tmp20_;
			{
				WnckWindow* _tmp21_ = NULL;
				WnckWorkspace* _tmp22_ = NULL;
				gboolean _tmp23_ = FALSE;
				_tmp21_ = window;
				_tmp22_ = desk;
				_tmp23_ = wnck_window_is_visible_on_workspace (_tmp21_, _tmp22_);
				if (_tmp23_) {
					WincmdCommand _tmp24_ = 0;
					_tmp24_ = command;
					switch (_tmp24_) {
						case WINCMD_COMMAND_NONE:
						{
							break;
						}
						case WINCMD_COMMAND_ICONIFY:
						{
							gboolean _tmp25_ = FALSE;
							gboolean _tmp26_ = FALSE;
							_tmp26_ = self->priv->_toggle_iconify_and_shade;
							if (!_tmp26_) {
								_tmp25_ = TRUE;
							} else {
								gboolean _tmp27_ = FALSE;
								_tmp27_ = self->priv->toggle_state;
								_tmp25_ = !_tmp27_;
							}
							if (_tmp25_) {
								WnckWindow* _tmp28_ = NULL;
								_tmp28_ = window;
								wnck_window_minimize (_tmp28_);
							} else {
								WnckWindow* _tmp29_ = NULL;
								guint32 _tmp30_ = 0U;
								_tmp29_ = window;
								_tmp30_ = gtk_get_current_event_time ();
								wnck_window_unminimize (_tmp29_, _tmp30_);
							}
							break;
						}
						case WINCMD_COMMAND_SHADE:
						{
							gboolean _tmp31_ = FALSE;
							gboolean _tmp32_ = FALSE;
							_tmp32_ = self->priv->_toggle_iconify_and_shade;
							if (!_tmp32_) {
								_tmp31_ = TRUE;
							} else {
								gboolean _tmp33_ = FALSE;
								_tmp33_ = self->priv->toggle_state;
								_tmp31_ = !_tmp33_;
							}
							if (_tmp31_) {
								WnckWindow* _tmp34_ = NULL;
								_tmp34_ = window;
								wnck_window_shade (_tmp34_);
							} else {
								WnckWindow* _tmp35_ = NULL;
								_tmp35_ = window;
								wnck_window_unshade (_tmp35_);
							}
							break;
						}
						default:
						break;
					}
				}
				_g_object_unref0 (window);
			}
		}
	}
	wincmd_adjust_toggle_state (self);
	_g_object_unref0 (desk);
	_g_object_unref0 (scr);
}


static void wincmd_adjust_toggle_state (Wincmd* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_toggle_iconify_and_shade;
	if (_tmp0_) {
		gboolean _tmp1_ = FALSE;
		_tmp1_ = self->priv->toggle_state;
		self->priv->toggle_state = !_tmp1_;
	} else {
		self->priv->toggle_state = TRUE;
	}
}


static gboolean wincmd_real_button_release_event (GtkWidget* base, GdkEventButton* e) {
	Wincmd * self;
	gboolean result = FALSE;
	GdkEventButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	self = (Wincmd*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = e;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ == ((guint) 2)) {
		WincmdCommand _tmp2_ = 0;
		_tmp2_ = self->priv->_middle_button_command;
		wincmd_execute_command (self, _tmp2_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


WincmdCommand wincmd_get_left_button_command (Wincmd* self) {
	WincmdCommand result;
	WincmdCommand _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_left_button_command;
	result = _tmp0_;
	return result;
}


void wincmd_set_left_button_command (Wincmd* self, WincmdCommand value) {
	WincmdCommand _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_left_button_command = _tmp0_;
	g_object_notify ((GObject *) self, "left-button-command");
}


WincmdCommand wincmd_get_middle_button_command (Wincmd* self) {
	WincmdCommand result;
	WincmdCommand _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_middle_button_command;
	result = _tmp0_;
	return result;
}


void wincmd_set_middle_button_command (Wincmd* self, WincmdCommand value) {
	WincmdCommand _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_middle_button_command = _tmp0_;
	g_object_notify ((GObject *) self, "middle-button-command");
}


gboolean wincmd_get_toggle_iconify_and_shade (Wincmd* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_toggle_iconify_and_shade;
	result = _tmp0_;
	return result;
}


void wincmd_set_toggle_iconify_and_shade (Wincmd* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_toggle_iconify_and_shade = _tmp0_;
	g_object_notify ((GObject *) self, "toggle-iconify-and-shade");
}


const gchar* wincmd_get_icon (Wincmd* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon;
	result = _tmp0_;
	return result;
}


void wincmd_set_icon (Wincmd* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_icon);
	self->priv->_icon = _tmp1_;
	g_object_notify ((GObject *) self, "icon");
}


static void wincmd_class_init (WincmdClass * klass) {
	wincmd_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (WincmdPrivate));
	((PanelAppletClass *) klass)->create = wincmd_real_create;
	((GtkWidgetClass *) klass)->button_release_event = wincmd_real_button_release_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_wincmd_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_wincmd_set_property;
	G_OBJECT_CLASS (klass)->finalize = wincmd_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_LEFT_BUTTON_COMMAND, g_param_spec_enum ("left-button-command", "left-button-command", "left-button-command", WINCMD_TYPE_COMMAND, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_MIDDLE_BUTTON_COMMAND, g_param_spec_enum ("middle-button-command", "middle-button-command", "middle-button-command", WINCMD_TYPE_COMMAND, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_TOGGLE_ICONIFY_AND_SHADE, g_param_spec_boolean ("toggle-iconify-and-shade", "toggle-iconify-and-shade", "toggle-iconify-and-shade", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_ICON, g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void wincmd_vala_panel_applet_configurable_interface_init (ValaPanelAppletConfigurableIface * iface) {
	wincmd_vala_panel_applet_configurable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_config_dialog = (GtkDialog* (*)(ValaPanelAppletConfigurable*)) wincmd_real_get_config_dialog;
}


static void wincmd_instance_init (Wincmd * self) {
	self->priv = WINCMD_GET_PRIVATE (self);
}


static void wincmd_finalize (GObject* obj) {
	Wincmd * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WINCMD, Wincmd);
	_g_object_unref0 (self->priv->button);
	_g_object_unref0 (self->priv->image);
	_g_free0 (self->priv->_icon);
	G_OBJECT_CLASS (wincmd_parent_class)->finalize (obj);
}


GType wincmd_get_type (void) {
	return wincmd_type_id;
}


GType wincmd_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (WincmdClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wincmd_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Wincmd), 0, (GInstanceInitFunc) wincmd_instance_init, NULL };
	static const GInterfaceInfo vala_panel_applet_configurable_info = { (GInterfaceInitFunc) wincmd_vala_panel_applet_configurable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	wincmd_type_id = g_type_module_register_type (module, VALA_PANEL_TYPE_APPLET, "Wincmd", &g_define_type_info, 0);
	g_type_module_add_interface (module, wincmd_type_id, VALA_PANEL_TYPE_APPLET_CONFIGURABLE, &vala_panel_applet_configurable_info);
	return wincmd_type_id;
}


static void _vala_wincmd_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Wincmd * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WINCMD, Wincmd);
	switch (property_id) {
		case WINCMD_LEFT_BUTTON_COMMAND:
		g_value_set_enum (value, wincmd_get_left_button_command (self));
		break;
		case WINCMD_MIDDLE_BUTTON_COMMAND:
		g_value_set_enum (value, wincmd_get_middle_button_command (self));
		break;
		case WINCMD_TOGGLE_ICONIFY_AND_SHADE:
		g_value_set_boolean (value, wincmd_get_toggle_iconify_and_shade (self));
		break;
		case WINCMD_ICON:
		g_value_set_string (value, wincmd_get_icon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_wincmd_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Wincmd * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WINCMD, Wincmd);
	switch (property_id) {
		case WINCMD_LEFT_BUTTON_COMMAND:
		wincmd_set_left_button_command (self, g_value_get_enum (value));
		break;
		case WINCMD_MIDDLE_BUTTON_COMMAND:
		wincmd_set_middle_button_command (self, g_value_get_enum (value));
		break;
		case WINCMD_TOGGLE_ICONIFY_AND_SHADE:
		wincmd_set_toggle_iconify_and_shade (self, g_value_get_boolean (value));
		break;
		case WINCMD_ICON:
		wincmd_set_icon (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


void peas_register_types (GTypeModule* module) {
	PeasObjectModule* objmodule = NULL;
	GTypeModule* _tmp0_ = NULL;
	PeasObjectModule* _tmp1_ = NULL;
	g_return_if_fail (module != NULL);
	wincmd_applet_register_type (module);
	wincmd_register_type (module);
	_tmp0_ = module;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, peas_object_module_get_type ()) ? ((PeasObjectModule*) _tmp0_) : NULL);
	objmodule = _tmp1_;
	peas_object_module_register_extension_type (objmodule, VALA_PANEL_TYPE_APPLET_PLUGIN, TYPE_WINCMD_APPLET);
	_g_object_unref0 (objmodule);
}



