/* plugin-settings.c generated by valac 0.32.1, the Vala compiler
 * generated from plugin-settings.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <lib/settings-manager.h>
#include <gio/gsettingsbackend.h>
#include <lib/c-lib/toplevel.h>
#include <lib/misc.h>
#include <stdio.h>
#include <lib/c-lib/panel-layout.h>

typedef struct _ValaPanelPluginSettings ValaPanelPluginSettings;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ValaPanelToplevelSettings ValaPanelToplevelSettings;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define __g_slist_free__vala_panel_plugin_settings_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__vala_panel_plugin_settings_free0_ (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _vala_panel_plugin_settings_free0(var) ((var == NULL) ? NULL : (var = (vala_panel_plugin_settings_free (var), NULL)))

struct _ValaPanelPluginSettings {
	gchar* path_append;
	GSettings* default_settings;
	GSettings* config_settings;
	guint number;
};

struct _ValaPanelToplevelSettings {
	GSList* plugins;
	GSettings* settings;
	GSettingsBackend* backend;
	gchar* filename;
	gchar* root_name;
	gchar* root_schema;
	gchar* root_path;
};



#define VALA_PANEL_ROOT_NAME "toplevel-settings"
void vala_panel_plugin_settings_free (ValaPanelPluginSettings* self);
static void vala_panel_plugin_settings_instance_init (ValaPanelPluginSettings * self);
void vala_panel_toplevel_settings_free (ValaPanelToplevelSettings* self);
ValaPanelPluginSettings* vala_panel_plugin_settings_new (ValaPanelToplevelSettings* settings, const gchar* name, guint num);
ValaPanelPluginSettings* vala_panel_plugin_settings_new (ValaPanelToplevelSettings* settings, const gchar* name, guint num);
static void vala_panel_toplevel_settings_instance_init (ValaPanelToplevelSettings * self);
static void _vala_panel_plugin_settings_free0_ (gpointer var);
static void _g_slist_free__vala_panel_plugin_settings_free0_ (GSList* self);
ValaPanelToplevelSettings* vala_panel_toplevel_settings_new_full (const gchar* file, const gchar* schema, const gchar* path, const gchar* root);
ValaPanelToplevelSettings* vala_panel_toplevel_settings_new_full (const gchar* file, const gchar* schema, const gchar* path, const gchar* root);
ValaPanelToplevelSettings* vala_panel_toplevel_settings_new (const gchar* file);
ValaPanelToplevelSettings* vala_panel_toplevel_settings_new (const gchar* file);
guint vala_panel_toplevel_settings_find_free_num (ValaPanelToplevelSettings* self);
ValaPanelPluginSettings* vala_panel_toplevel_settings_add_plugin_settings_full (ValaPanelToplevelSettings* self, const gchar* name, guint num);
ValaPanelPluginSettings* vala_panel_toplevel_settings_get_settings_by_num (ValaPanelToplevelSettings* self, guint num);
ValaPanelPluginSettings* vala_panel_toplevel_settings_add_plugin_settings (ValaPanelToplevelSettings* self, const gchar* name);
void vala_panel_toplevel_settings_remove_plugin_settings (ValaPanelToplevelSettings* self, guint num);
gboolean vala_panel_toplevel_settings_init_plugin_list (ValaPanelToplevelSettings* self);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static gpointer _g_settings_schema_source_ref0 (gpointer self) {
	return self ? g_settings_schema_source_ref (self) : NULL;
}


ValaPanelPluginSettings* vala_panel_plugin_settings_new (ValaPanelToplevelSettings* settings, const gchar* name, guint num) {
	ValaPanelPluginSettings* self;
	guint _tmp0_ = 0U;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* id = NULL;
	ValaPanelToplevelSettings* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* path = NULL;
	ValaPanelToplevelSettings* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gchar* _tmp10_ = NULL;
	ValaPanelToplevelSettings* _tmp11_ = NULL;
	GSettingsBackend* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	GSettings* _tmp14_ = NULL;
	GSettingsSchemaSource* source = NULL;
	GSettingsSchemaSource* _tmp15_ = NULL;
	GSettingsSchemaSource* _tmp16_ = NULL;
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	GSettingsSchema* _tmp19_ = NULL;
	GSettingsSchema* _tmp20_ = NULL;
	g_return_val_if_fail (settings != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = g_slice_new0 (ValaPanelPluginSettings);
	vala_panel_plugin_settings_instance_init (self);
	_tmp0_ = num;
	self->number = _tmp0_;
	_tmp1_ = name;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (self->path_append);
	self->path_append = _tmp2_;
	_tmp3_ = settings;
	_tmp4_ = _tmp3_->root_schema;
	_tmp5_ = self->path_append;
	_tmp6_ = g_strdup_printf ("%s.%s", _tmp4_, _tmp5_);
	id = _tmp6_;
	_tmp7_ = settings;
	_tmp8_ = _tmp7_->root_path;
	_tmp9_ = self->number;
	_tmp10_ = g_strdup_printf ("%s%u/", _tmp8_, _tmp9_);
	path = _tmp10_;
	_tmp11_ = settings;
	_tmp12_ = _tmp11_->backend;
	_tmp13_ = path;
	_tmp14_ = g_settings_new_with_backend_and_path (VALA_PANEL_PLUGIN_SCHEMA, _tmp12_, _tmp13_);
	_g_object_unref0 (self->default_settings);
	self->default_settings = _tmp14_;
	_tmp15_ = g_settings_schema_source_get_default ();
	_tmp16_ = _g_settings_schema_source_ref0 (_tmp15_);
	source = _tmp16_;
	_tmp17_ = source;
	_tmp18_ = id;
	_tmp19_ = g_settings_schema_source_lookup (_tmp17_, _tmp18_, TRUE);
	schema = _tmp19_;
	_tmp20_ = schema;
	if (_tmp20_ != NULL) {
		const gchar* _tmp21_ = NULL;
		ValaPanelToplevelSettings* _tmp22_ = NULL;
		GSettingsBackend* _tmp23_ = NULL;
		const gchar* _tmp24_ = NULL;
		GSettings* _tmp25_ = NULL;
		_tmp21_ = id;
		_tmp22_ = settings;
		_tmp23_ = _tmp22_->backend;
		_tmp24_ = path;
		_tmp25_ = g_settings_new_with_backend_and_path (_tmp21_, _tmp23_, _tmp24_);
		_g_object_unref0 (self->config_settings);
		self->config_settings = _tmp25_;
	}
	_g_settings_schema_unref0 (schema);
	_g_settings_schema_source_unref0 (source);
	_g_free0 (path);
	_g_free0 (id);
	return self;
}


static void vala_panel_plugin_settings_instance_init (ValaPanelPluginSettings * self) {
}


void vala_panel_plugin_settings_free (ValaPanelPluginSettings* self) {
	_g_free0 (self->path_append);
	_g_object_unref0 (self->default_settings);
	_g_object_unref0 (self->config_settings);
	g_slice_free (ValaPanelPluginSettings, self);
}


static void _vala_panel_plugin_settings_free0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (vala_panel_plugin_settings_free (var), NULL));
}


static void _g_slist_free__vala_panel_plugin_settings_free0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _vala_panel_plugin_settings_free0_, NULL);
	g_slist_free (self);
}


ValaPanelToplevelSettings* vala_panel_toplevel_settings_new_full (const gchar* file, const gchar* schema, const gchar* path, const gchar* root) {
	ValaPanelToplevelSettings* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	GSettingsBackend* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	GSettingsBackend* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	GSettings* _tmp15_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (schema != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	self = g_slice_new0 (ValaPanelToplevelSettings);
	vala_panel_toplevel_settings_instance_init (self);
	_tmp0_ = file;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->filename);
	self->filename = _tmp1_;
	_tmp2_ = root;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (self->root_name);
	self->root_name = _tmp3_;
	_tmp4_ = path;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 (self->root_path);
	self->root_path = _tmp5_;
	_tmp6_ = schema;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 (self->root_schema);
	self->root_schema = _tmp7_;
	_tmp8_ = file;
	_tmp9_ = path;
	_tmp10_ = root;
	_tmp11_ = g_keyfile_settings_backend_new (_tmp8_, _tmp9_, _tmp10_);
	_g_object_unref0 (self->backend);
	self->backend = _tmp11_;
	_tmp12_ = schema;
	_tmp13_ = self->backend;
	_tmp14_ = path;
	_tmp15_ = g_settings_new_with_backend_and_path (_tmp12_, _tmp13_, _tmp14_);
	_g_object_unref0 (self->settings);
	self->settings = _tmp15_;
	return self;
}


ValaPanelToplevelSettings* vala_panel_toplevel_settings_new (const gchar* file) {
	ValaPanelToplevelSettings* self;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	vala_panel_toplevel_settings_instance_init (self);
	_tmp0_ = file;
	self = (ValaPanelToplevelSettings*) vala_panel_toplevel_settings_new_full (_tmp0_, VALA_PANEL_SETTINGS_SCHEMA, VALA_PANEL_SETTINGS_PATH, VALA_PANEL_ROOT_NAME);
	return self;
}


guint vala_panel_toplevel_settings_find_free_num (ValaPanelToplevelSettings* self) {
	guint result = 0U;
	GKeyFile* f = NULL;
	GKeyFile* _tmp0_ = NULL;
	GHashTable* numtable = NULL;
	GHashFunc _tmp3_ = NULL;
	GEqualFunc _tmp4_ = NULL;
	GHashTable* _tmp5_ = NULL;
	gint len = 0;
	GKeyFile* _tmp6_ = NULL;
	gsize _tmp7_;
	gchar** _tmp8_ = NULL;
	gchar** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	gint _tmp10_ = 0;
	GKeyFile* _tmp11_ = NULL;
	gsize _tmp12_;
	gchar** _tmp13_ = NULL;
	gint _tmp27_ = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = g_key_file_new ();
	f = _tmp0_;
	{
		GKeyFile* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		_tmp1_ = f;
		_tmp2_ = self->filename;
		g_key_file_load_from_file (_tmp1_, _tmp2_, G_KEY_FILE_KEEP_COMMENTS, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch6_g_key_file_error;
			}
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch6_g_file_error;
			}
			_g_key_file_unref0 (f);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0U;
		}
	}
	goto __finally6;
	__catch6_g_key_file_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (e);
	}
	goto __finally6;
	__catch6_g_file_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_key_file_unref0 (f);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0U;
	}
	_tmp3_ = g_direct_hash;
	_tmp4_ = g_direct_equal;
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, NULL, NULL);
	numtable = _tmp5_;
	_tmp6_ = f;
	_tmp8_ = g_key_file_get_groups (_tmp6_, &_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp9__length1 = _tmp7_;
	_tmp10_ = _tmp7_;
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
	len = _tmp10_;
	_tmp11_ = f;
	_tmp13_ = g_key_file_get_groups (_tmp11_, &_tmp12_);
	{
		gchar** grp_collection = NULL;
		gint grp_collection_length1 = 0;
		gint _grp_collection_size_ = 0;
		gint grp_it = 0;
		grp_collection = _tmp13_;
		grp_collection_length1 = _tmp12_;
		for (grp_it = 0; grp_it < _tmp12_; grp_it = grp_it + 1) {
			gchar* _tmp14_ = NULL;
			gchar* grp = NULL;
			_tmp14_ = g_strdup (grp_collection[grp_it]);
			grp = _tmp14_;
			{
				const gchar* _tmp15_ = NULL;
				const gchar* _tmp16_ = NULL;
				GHashTable* _tmp17_ = NULL;
				const gchar* _tmp18_ = NULL;
				gint _tmp19_ = 0;
				_tmp15_ = grp;
				_tmp16_ = self->root_name;
				if (g_strcmp0 (_tmp15_, _tmp16_) == 0) {
					_g_free0 (grp);
					continue;
				}
				_tmp17_ = numtable;
				_tmp18_ = grp;
				_tmp19_ = atoi (_tmp18_);
				g_hash_table_add (_tmp17_, (gpointer) ((gintptr) _tmp19_));
				_g_free0 (grp);
			}
		}
		grp_collection = (_vala_array_free (grp_collection, grp_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp20_ = FALSE;
			_tmp20_ = TRUE;
			while (TRUE) {
				gint _tmp22_ = 0;
				gint _tmp23_ = 0;
				GHashTable* _tmp24_ = NULL;
				gint _tmp25_ = 0;
				gboolean _tmp26_ = FALSE;
				if (!_tmp20_) {
					gint _tmp21_ = 0;
					_tmp21_ = i;
					i = _tmp21_ + 1;
				}
				_tmp20_ = FALSE;
				_tmp22_ = i;
				_tmp23_ = len;
				if (!(_tmp22_ < _tmp23_)) {
					break;
				}
				_tmp24_ = numtable;
				_tmp25_ = i;
				_tmp26_ = g_hash_table_contains (_tmp24_, (gpointer) ((gintptr) _tmp25_));
				if (!_tmp26_) {
					result = (guint) i;
					_g_hash_table_unref0 (numtable);
					_g_key_file_unref0 (f);
					return result;
				}
			}
		}
	}
	_tmp27_ = len;
	result = (guint) (_tmp27_ + 1);
	_g_hash_table_unref0 (numtable);
	_g_key_file_unref0 (f);
	return result;
}


ValaPanelPluginSettings* vala_panel_toplevel_settings_add_plugin_settings_full (ValaPanelToplevelSettings* self, const gchar* name, guint num) {
	ValaPanelPluginSettings* result = NULL;
	ValaPanelPluginSettings* settings = NULL;
	const gchar* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	ValaPanelPluginSettings* _tmp2_ = NULL;
	ValaPanelPluginSettings* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
	ValaPanelPluginSettings* _tmp5_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	_tmp1_ = num;
	_tmp2_ = vala_panel_plugin_settings_new (self, _tmp0_, _tmp1_);
	settings = _tmp2_;
	_tmp3_ = settings;
	settings = NULL;
	self->plugins = g_slist_append (self->plugins, _tmp3_);
	_tmp4_ = num;
	_tmp5_ = vala_panel_toplevel_settings_get_settings_by_num (self, _tmp4_);
	result = _tmp5_;
	_vala_panel_plugin_settings_free0 (settings);
	return result;
}


ValaPanelPluginSettings* vala_panel_toplevel_settings_add_plugin_settings (ValaPanelToplevelSettings* self, const gchar* name) {
	ValaPanelPluginSettings* result = NULL;
	guint num = 0U;
	guint _tmp0_ = 0U;
	const gchar* _tmp1_ = NULL;
	ValaPanelPluginSettings* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = vala_panel_toplevel_settings_find_free_num (self);
	num = _tmp0_;
	_tmp1_ = name;
	_tmp2_ = vala_panel_toplevel_settings_add_plugin_settings_full (self, _tmp1_, num);
	result = _tmp2_;
	return result;
}


void vala_panel_toplevel_settings_remove_plugin_settings (ValaPanelToplevelSettings* self, guint num) {
	GSList* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->plugins;
	{
		GSList* tmp_collection = NULL;
		GSList* tmp_it = NULL;
		tmp_collection = _tmp0_;
		for (tmp_it = tmp_collection; tmp_it != NULL; tmp_it = tmp_it->next) {
			ValaPanelPluginSettings* tmp = NULL;
			tmp = (ValaPanelPluginSettings*) tmp_it->data;
			{
				ValaPanelPluginSettings* _tmp1_ = NULL;
				guint _tmp2_ = 0U;
				guint _tmp3_ = 0U;
				_tmp1_ = tmp;
				_tmp2_ = _tmp1_->number;
				_tmp3_ = num;
				if (_tmp2_ == _tmp3_) {
					ValaPanelPluginSettings* _tmp4_ = NULL;
					ValaPanelPluginSettings* _tmp5_ = NULL;
					GSettings* _tmp6_ = NULL;
					ValaPanelPluginSettings* _tmp9_ = NULL;
					GSettings* _tmp10_ = NULL;
					_tmp4_ = tmp;
					self->plugins = g_slist_remove (self->plugins, _tmp4_);
					_tmp5_ = tmp;
					_tmp6_ = _tmp5_->config_settings;
					if (_tmp6_ != NULL) {
						ValaPanelPluginSettings* _tmp7_ = NULL;
						GSettings* _tmp8_ = NULL;
						_tmp7_ = tmp;
						_tmp8_ = _tmp7_->config_settings;
						vala_panel_reset_schema_with_children (_tmp8_);
					}
					_tmp9_ = tmp;
					_tmp10_ = _tmp9_->default_settings;
					vala_panel_reset_schema_with_children (_tmp10_);
					return;
				}
			}
		}
	}
}


gboolean vala_panel_toplevel_settings_init_plugin_list (ValaPanelToplevelSettings* self) {
	gboolean result = FALSE;
	GSList* _tmp0_ = NULL;
	GKeyFile* f = NULL;
	GKeyFile* _tmp1_ = NULL;
	gchar** groups = NULL;
	GKeyFile* _tmp7_ = NULL;
	gsize _tmp8_;
	gchar** _tmp9_ = NULL;
	gint groups_length1 = 0;
	gint _groups_size_ = 0;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->plugins;
	if (_tmp0_ != NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = g_key_file_new ();
	f = _tmp1_;
	{
		GKeyFile* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		_tmp2_ = f;
		_tmp3_ = self->filename;
		g_key_file_load_from_file (_tmp2_, _tmp3_, G_KEY_FILE_KEEP_COMMENTS, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch7_g_error;
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "Cannot load config file: %s\n", _tmp6_);
		result = FALSE;
		_g_error_free0 (e);
		_g_key_file_unref0 (f);
		return result;
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_key_file_unref0 (f);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_tmp7_ = f;
	_tmp9_ = g_key_file_get_groups (_tmp7_, &_tmp8_);
	groups = _tmp9_;
	groups_length1 = _tmp8_;
	_groups_size_ = groups_length1;
	_tmp10_ = groups;
	_tmp10__length1 = groups_length1;
	{
		gchar** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it = 0;
		group_collection = _tmp10_;
		group_collection_length1 = _tmp10__length1;
		for (group_it = 0; group_it < _tmp10__length1; group_it = group_it + 1) {
			gchar* _tmp11_ = NULL;
			gchar* group = NULL;
			_tmp11_ = g_strdup (group_collection[group_it]);
			group = _tmp11_;
			{
				{
					gchar* name = NULL;
					GKeyFile* _tmp12_ = NULL;
					const gchar* _tmp13_ = NULL;
					gchar* _tmp14_ = NULL;
					const gchar* _tmp15_ = NULL;
					const gchar* _tmp16_ = NULL;
					const gchar* _tmp17_ = NULL;
					gchar* _tmp18_ = NULL;
					const gchar* _tmp19_ = NULL;
					const gchar* _tmp20_ = NULL;
					gint _tmp21_ = 0;
					_tmp12_ = f;
					_tmp13_ = group;
					_tmp14_ = g_key_file_get_string (_tmp12_, _tmp13_, VALA_PANEL_KEY_NAME, &_inner_error_);
					name = _tmp14_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
							goto __catch8_g_key_file_error;
						}
						_g_free0 (group);
						groups = (_vala_array_free (groups, groups_length1, (GDestroyNotify) g_free), NULL);
						_g_key_file_unref0 (f);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return FALSE;
					}
					_tmp15_ = name;
					_tmp16_ = g_strdelimit (_tmp15_, "'", ' ');
					_tmp17_ = g_strstrip (_tmp16_);
					_tmp18_ = g_strdup (_tmp17_);
					_g_free0 (name);
					name = _tmp18_;
					_tmp19_ = name;
					_tmp20_ = group;
					_tmp21_ = atoi (_tmp20_);
					vala_panel_toplevel_settings_add_plugin_settings_full (self, _tmp19_, (guint) _tmp21_);
					_g_free0 (name);
				}
				goto __finally8;
				__catch8_g_key_file_error:
				{
					GError* e = NULL;
					e = _inner_error_;
					_inner_error_ = NULL;
					{
						GKeyFile* _tmp22_ = NULL;
						const gchar* _tmp23_ = NULL;
						_tmp22_ = f;
						_tmp23_ = group;
						g_key_file_remove_group (_tmp22_, _tmp23_, &_inner_error_);
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							if (_inner_error_->domain == G_KEY_FILE_ERROR) {
								goto __catch9_g_key_file_error;
							}
							_g_error_free0 (e);
							_g_free0 (group);
							groups = (_vala_array_free (groups, groups_length1, (GDestroyNotify) g_free), NULL);
							_g_key_file_unref0 (f);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return FALSE;
						}
					}
					goto __finally9;
					__catch9_g_key_file_error:
					{
						GError* e = NULL;
						e = _inner_error_;
						_inner_error_ = NULL;
						_g_error_free0 (e);
					}
					__finally9:
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_error_free0 (e);
						_g_error_free0 (e);
						_g_free0 (group);
						groups = (_vala_array_free (groups, groups_length1, (GDestroyNotify) g_free), NULL);
						_g_key_file_unref0 (f);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return FALSE;
					}
					_g_error_free0 (e);
				}
				__finally8:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_free0 (group);
					groups = (_vala_array_free (groups, groups_length1, (GDestroyNotify) g_free), NULL);
					_g_key_file_unref0 (f);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return FALSE;
				}
				_g_free0 (group);
			}
		}
	}
	result = TRUE;
	groups = (_vala_array_free (groups, groups_length1, (GDestroyNotify) g_free), NULL);
	_g_key_file_unref0 (f);
	return result;
}


ValaPanelPluginSettings* vala_panel_toplevel_settings_get_settings_by_num (ValaPanelToplevelSettings* self, guint num) {
	ValaPanelPluginSettings* result = NULL;
	GSList* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->plugins;
	{
		GSList* pl_collection = NULL;
		GSList* pl_it = NULL;
		pl_collection = _tmp0_;
		for (pl_it = pl_collection; pl_it != NULL; pl_it = pl_it->next) {
			ValaPanelPluginSettings* pl = NULL;
			pl = (ValaPanelPluginSettings*) pl_it->data;
			{
				ValaPanelPluginSettings* _tmp1_ = NULL;
				guint _tmp2_ = 0U;
				guint _tmp3_ = 0U;
				_tmp1_ = pl;
				_tmp2_ = _tmp1_->number;
				_tmp3_ = num;
				if (_tmp2_ == _tmp3_) {
					ValaPanelPluginSettings* _tmp4_ = NULL;
					_tmp4_ = pl;
					result = _tmp4_;
					return result;
				}
			}
		}
	}
	result = NULL;
	return result;
}


static void vala_panel_toplevel_settings_instance_init (ValaPanelToplevelSettings * self) {
}


void vala_panel_toplevel_settings_free (ValaPanelToplevelSettings* self) {
	__g_slist_free__vala_panel_plugin_settings_free0_0 (self->plugins);
	_g_object_unref0 (self->settings);
	_g_object_unref0 (self->backend);
	_g_free0 (self->filename);
	_g_free0 (self->root_name);
	_g_free0 (self->root_schema);
	_g_free0 (self->root_path);
	g_slice_free (ValaPanelToplevelSettings, self);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



